/* DateIterator.c generated by valac 0.56.18, the Vala compiler
 * generated from DateIterator.vala, do not modify */

/*
 * Copyright 2011-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include "datetime.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	UTIL_DATE_ITERATOR_0_PROPERTY,
	UTIL_DATE_ITERATOR_CURRENT_PROPERTY,
	UTIL_DATE_ITERATOR_RANGE_PROPERTY,
	UTIL_DATE_ITERATOR_VALID_PROPERTY,
	UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY,
	UTIL_DATE_ITERATOR_NUM_PROPERTIES
};
static GParamSpec* util_date_iterator_properties[UTIL_DATE_ITERATOR_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UtilDateIteratorPrivate {
	GDateTime* _current;
	UtilDateRange* _range;
};

static gint UtilDateIterator_private_offset;
static gpointer util_date_iterator_parent_class = NULL;
static GeeTraversableIface * util_date_iterator_gee_traversable_parent_iface = NULL;
static GeeIteratorIface * util_date_iterator_gee_iterator_parent_iface = NULL;

static gboolean util_date_iterator_real_foreach (GeeTraversable* base,
                                          GeeForallFunc f,
                                          gpointer f_target);
static gboolean util_date_iterator_real_next (GeeIterator* base);
static gboolean util_date_iterator_real_has_next (GeeIterator* base);
static GDateTime* util_date_iterator_real_get (GeeIterator* base);
static void util_date_iterator_real_remove (GeeIterator* base);
static void util_date_iterator_finalize (GObject * obj);
static GType util_date_iterator_get_type_once (void);
static void _vala_util_date_iterator_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_util_date_iterator_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
util_date_iterator_get_instance_private (UtilDateIterator* self)
{
	return G_STRUCT_MEMBER_P (self, UtilDateIterator_private_offset);
}

UtilDateIterator*
util_date_iterator_construct (GType object_type,
                              UtilDateRange* range)
{
	UtilDateIterator * self = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 40 "../src/DateIterator.vala"
	g_return_val_if_fail (range != NULL, NULL);
#line 41 "../src/DateIterator.vala"
	_tmp0_ = util_date_range_get_first_dt (range);
#line 41 "../src/DateIterator.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/DateIterator.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, -1);
#line 41 "../src/DateIterator.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/DateIterator.vala"
	self = (UtilDateIterator*) g_object_new (object_type, "range", range, "current", _tmp3_, NULL);
#line 41 "../src/DateIterator.vala"
	_g_date_time_unref0 (_tmp3_);
#line 40 "../src/DateIterator.vala"
	return self;
#line 111 "DateIterator.c"
}

UtilDateIterator*
util_date_iterator_new (UtilDateRange* range)
{
#line 40 "../src/DateIterator.vala"
	return util_date_iterator_construct (UTIL_TYPE_DATE_ITERATOR, range);
#line 119 "DateIterator.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 48 "../src/DateIterator.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 127 "DateIterator.c"
}

static gboolean
util_date_iterator_real_foreach (GeeTraversable* base,
                                 GeeForallFunc f,
                                 gpointer f_target)
{
	UtilDateIterator * self;
	GDateTime* element = NULL;
	UtilDateRange* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean result;
#line 47 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 48 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_range;
#line 48 "../src/DateIterator.vala"
	_tmp1_ = util_date_range_get_first_dt (_tmp0_);
#line 48 "../src/DateIterator.vala"
	_tmp2_ = _tmp1_;
#line 48 "../src/DateIterator.vala"
	_tmp3_ = _g_date_time_ref0 (_tmp2_);
#line 48 "../src/DateIterator.vala"
	element = _tmp3_;
#line 50 "../src/DateIterator.vala"
	while (TRUE) {
#line 156 "DateIterator.c"
		GDateTime* _tmp4_;
		UtilDateRange* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
#line 50 "../src/DateIterator.vala"
		_tmp4_ = element;
#line 50 "../src/DateIterator.vala"
		_tmp5_ = self->priv->_range;
#line 50 "../src/DateIterator.vala"
		_tmp6_ = util_date_range_get_last_dt (_tmp5_);
#line 50 "../src/DateIterator.vala"
		_tmp7_ = _tmp6_;
#line 50 "../src/DateIterator.vala"
		if (!(g_date_time_compare (_tmp4_, _tmp7_) < 0)) {
#line 50 "../src/DateIterator.vala"
			break;
#line 177 "DateIterator.c"
		}
#line 51 "../src/DateIterator.vala"
		_tmp8_ = element;
#line 51 "../src/DateIterator.vala"
		_tmp9_ = _g_date_time_ref0 (_tmp8_);
#line 51 "../src/DateIterator.vala"
		if (f (_tmp9_, f_target) == FALSE) {
#line 52 "../src/DateIterator.vala"
			result = FALSE;
#line 52 "../src/DateIterator.vala"
			_g_date_time_unref0 (element);
#line 52 "../src/DateIterator.vala"
			return result;
#line 191 "DateIterator.c"
		}
#line 55 "../src/DateIterator.vala"
		_tmp10_ = element;
#line 55 "../src/DateIterator.vala"
		_tmp11_ = g_date_time_add_days (_tmp10_, 1);
#line 55 "../src/DateIterator.vala"
		_g_date_time_unref0 (element);
#line 55 "../src/DateIterator.vala"
		element = _tmp11_;
#line 201 "DateIterator.c"
	}
#line 58 "../src/DateIterator.vala"
	result = TRUE;
#line 58 "../src/DateIterator.vala"
	_g_date_time_unref0 (element);
#line 58 "../src/DateIterator.vala"
	return result;
#line 209 "DateIterator.c"
}

static gboolean
util_date_iterator_real_next (GeeIterator* base)
{
	UtilDateIterator * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean result;
#line 61 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 62 "../src/DateIterator.vala"
	if (!gee_iterator_has_next ((GeeIterator*) self)) {
#line 63 "../src/DateIterator.vala"
		result = FALSE;
#line 63 "../src/DateIterator.vala"
		return result;
#line 228 "DateIterator.c"
	}
#line 66 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 66 "../src/DateIterator.vala"
	_tmp1_ = g_date_time_add_days (_tmp0_, 1);
#line 66 "../src/DateIterator.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/DateIterator.vala"
	util_date_iterator_set_current (self, _tmp2_);
#line 66 "../src/DateIterator.vala"
	_g_date_time_unref0 (_tmp2_);
#line 68 "../src/DateIterator.vala"
	result = TRUE;
#line 68 "../src/DateIterator.vala"
	return result;
#line 244 "DateIterator.c"
}

static gboolean
util_date_iterator_real_has_next (GeeIterator* base)
{
	UtilDateIterator * self;
	GDateTime* _tmp0_;
	UtilDateRange* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean result;
#line 71 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 72 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 72 "../src/DateIterator.vala"
	_tmp1_ = self->priv->_range;
#line 72 "../src/DateIterator.vala"
	_tmp2_ = util_date_range_get_last_dt (_tmp1_);
#line 72 "../src/DateIterator.vala"
	_tmp3_ = _tmp2_;
#line 72 "../src/DateIterator.vala"
	result = g_date_time_compare (_tmp0_, _tmp3_) < 0;
#line 72 "../src/DateIterator.vala"
	return result;
#line 270 "DateIterator.c"
}

static GDateTime*
util_date_iterator_real_get (GeeIterator* base)
{
	UtilDateIterator * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* result;
#line 75 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 76 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 76 "../src/DateIterator.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 76 "../src/DateIterator.vala"
	result = _tmp1_;
#line 76 "../src/DateIterator.vala"
	return result;
#line 290 "DateIterator.c"
}

static void
util_date_iterator_real_remove (GeeIterator* base)
{
	UtilDateIterator * self;
#line 79 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 80 "../src/DateIterator.vala"
	g_assert_not_reached ();
#line 301 "DateIterator.c"
}

GDateTime*
util_date_iterator_get_current (UtilDateIterator* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 23 "../src/DateIterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 23 "../src/DateIterator.vala"
	result = _tmp0_;
#line 23 "../src/DateIterator.vala"
	return result;
#line 317 "DateIterator.c"
}

void
util_date_iterator_set_current (UtilDateIterator* self,
                                GDateTime* value)
{
	GDateTime* old_value;
#line 23 "../src/DateIterator.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/DateIterator.vala"
	old_value = util_date_iterator_get_current (self);
#line 23 "../src/DateIterator.vala"
	if (old_value != value) {
#line 331 "DateIterator.c"
		GDateTime* _tmp0_;
#line 23 "../src/DateIterator.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 23 "../src/DateIterator.vala"
		_g_date_time_unref0 (self->priv->_current);
#line 23 "../src/DateIterator.vala"
		self->priv->_current = _tmp0_;
#line 23 "../src/DateIterator.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_iterator_properties[UTIL_DATE_ITERATOR_CURRENT_PROPERTY]);
#line 341 "DateIterator.c"
	}
}

UtilDateRange*
util_date_iterator_get_range (UtilDateIterator* self)
{
	UtilDateRange* result;
	UtilDateRange* _tmp0_;
#line 24 "../src/DateIterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/DateIterator.vala"
	_tmp0_ = self->priv->_range;
#line 24 "../src/DateIterator.vala"
	result = _tmp0_;
#line 24 "../src/DateIterator.vala"
	return result;
#line 358 "DateIterator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/DateIterator.vala"
	return self ? g_object_ref (self) : NULL;
#line 366 "DateIterator.c"
}

static void
util_date_iterator_set_range (UtilDateIterator* self,
                              UtilDateRange* value)
{
	UtilDateRange* old_value;
#line 24 "../src/DateIterator.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/DateIterator.vala"
	old_value = util_date_iterator_get_range (self);
#line 24 "../src/DateIterator.vala"
	if (old_value != value) {
#line 380 "DateIterator.c"
		UtilDateRange* _tmp0_;
#line 24 "../src/DateIterator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/DateIterator.vala"
		_g_object_unref0 (self->priv->_range);
#line 24 "../src/DateIterator.vala"
		self->priv->_range = _tmp0_;
#line 24 "../src/DateIterator.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_iterator_properties[UTIL_DATE_ITERATOR_RANGE_PROPERTY]);
#line 390 "DateIterator.c"
	}
}

static gboolean
util_date_iterator_real_get_valid (GeeIterator* base)
{
	gboolean result;
	UtilDateIterator* self;
#line 28 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 29 "../src/DateIterator.vala"
	result = TRUE;
#line 29 "../src/DateIterator.vala"
	return result;
#line 405 "DateIterator.c"
}

static gboolean
util_date_iterator_real_get_read_only (GeeIterator* base)
{
	gboolean result;
	UtilDateIterator* self;
#line 35 "../src/DateIterator.vala"
	self = (UtilDateIterator*) base;
#line 36 "../src/DateIterator.vala"
	result = FALSE;
#line 36 "../src/DateIterator.vala"
	return result;
#line 419 "DateIterator.c"
}

static void
util_date_iterator_class_init (UtilDateIteratorClass * klass,
                               gpointer klass_data)
{
#line 22 "../src/DateIterator.vala"
	util_date_iterator_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/DateIterator.vala"
	g_type_class_adjust_private_offset (klass, &UtilDateIterator_private_offset);
#line 22 "../src/DateIterator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_util_date_iterator_get_property;
#line 22 "../src/DateIterator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_util_date_iterator_set_property;
#line 22 "../src/DateIterator.vala"
	G_OBJECT_CLASS (klass)->finalize = util_date_iterator_finalize;
#line 22 "../src/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_ITERATOR_CURRENT_PROPERTY, util_date_iterator_properties[UTIL_DATE_ITERATOR_CURRENT_PROPERTY] = g_param_spec_boxed ("current", "current", "current", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../src/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_ITERATOR_RANGE_PROPERTY, util_date_iterator_properties[UTIL_DATE_ITERATOR_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", UTIL_TYPE_DATE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_ITERATOR_VALID_PROPERTY, util_date_iterator_properties[UTIL_DATE_ITERATOR_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY, util_date_iterator_properties[UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 444 "DateIterator.c"
}

static GType
util_date_iterator_gee_traversable_get_g_type (UtilDateIterator* self)
{
#line 22 "../src/DateIterator.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 452 "DateIterator.c"
}

static GBoxedCopyFunc
util_date_iterator_gee_traversable_get_g_dup_func (UtilDateIterator* self)
{
#line 22 "../src/DateIterator.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 460 "DateIterator.c"
}

static GDestroyNotify
util_date_iterator_gee_traversable_get_g_destroy_func (UtilDateIterator* self)
{
#line 22 "../src/DateIterator.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 468 "DateIterator.c"
}

static void
util_date_iterator_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                   gpointer iface_data)
{
#line 22 "../src/DateIterator.vala"
	util_date_iterator_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../src/DateIterator.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) util_date_iterator_real_foreach;
#line 22 "../src/DateIterator.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) util_date_iterator_gee_traversable_get_g_type;
#line 22 "../src/DateIterator.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) util_date_iterator_gee_traversable_get_g_dup_func;
#line 22 "../src/DateIterator.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) util_date_iterator_gee_traversable_get_g_destroy_func;
#line 485 "DateIterator.c"
}

static void
util_date_iterator_gee_iterator_interface_init (GeeIteratorIface * iface,
                                                gpointer iface_data)
{
#line 22 "../src/DateIterator.vala"
	util_date_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../src/DateIterator.vala"
	iface->next = (gboolean (*) (GeeIterator*)) util_date_iterator_real_next;
#line 22 "../src/DateIterator.vala"
	iface->has_next = (gboolean (*) (GeeIterator*)) util_date_iterator_real_has_next;
#line 22 "../src/DateIterator.vala"
	iface->get = (gpointer (*) (GeeIterator*)) util_date_iterator_real_get;
#line 22 "../src/DateIterator.vala"
	iface->remove = (void (*) (GeeIterator*)) util_date_iterator_real_remove;
#line 22 "../src/DateIterator.vala"
	iface->get_valid = util_date_iterator_real_get_valid;
#line 22 "../src/DateIterator.vala"
	iface->get_read_only = util_date_iterator_real_get_read_only;
#line 506 "DateIterator.c"
}

static void
util_date_iterator_instance_init (UtilDateIterator * self,
                                  gpointer klass)
{
#line 22 "../src/DateIterator.vala"
	self->priv = util_date_iterator_get_instance_private (self);
#line 515 "DateIterator.c"
}

static void
util_date_iterator_finalize (GObject * obj)
{
	UtilDateIterator * self;
#line 22 "../src/DateIterator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_TYPE_DATE_ITERATOR, UtilDateIterator);
#line 23 "../src/DateIterator.vala"
	_g_date_time_unref0 (self->priv->_current);
#line 24 "../src/DateIterator.vala"
	_g_object_unref0 (self->priv->_range);
#line 22 "../src/DateIterator.vala"
	G_OBJECT_CLASS (util_date_iterator_parent_class)->finalize (obj);
#line 530 "DateIterator.c"
}

static GType
util_date_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UtilDateIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_date_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilDateIterator), 0, (GInstanceInitFunc) util_date_iterator_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) util_date_iterator_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) util_date_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType util_date_iterator_type_id;
	util_date_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "UtilDateIterator", &g_define_type_info, 0);
	g_type_add_interface_static (util_date_iterator_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (util_date_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
	UtilDateIterator_private_offset = g_type_add_instance_private (util_date_iterator_type_id, sizeof (UtilDateIteratorPrivate));
	return util_date_iterator_type_id;
}

GType
util_date_iterator_get_type (void)
{
	static volatile gsize util_date_iterator_type_id__once = 0;
	if (g_once_init_enter (&util_date_iterator_type_id__once)) {
		GType util_date_iterator_type_id;
		util_date_iterator_type_id = util_date_iterator_get_type_once ();
		g_once_init_leave (&util_date_iterator_type_id__once, util_date_iterator_type_id);
	}
	return util_date_iterator_type_id__once;
}

static void
_vala_util_date_iterator_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	UtilDateIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_ITERATOR, UtilDateIterator);
#line 22 "../src/DateIterator.vala"
	switch (property_id) {
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_CURRENT_PROPERTY:
#line 22 "../src/DateIterator.vala"
		g_value_set_boxed (value, util_date_iterator_get_current (self));
#line 22 "../src/DateIterator.vala"
		break;
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_RANGE_PROPERTY:
#line 22 "../src/DateIterator.vala"
		g_value_set_object (value, util_date_iterator_get_range (self));
#line 22 "../src/DateIterator.vala"
		break;
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_VALID_PROPERTY:
#line 22 "../src/DateIterator.vala"
		g_value_set_boolean (value, gee_iterator_get_valid ((GeeIterator*) self));
#line 22 "../src/DateIterator.vala"
		break;
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY:
#line 22 "../src/DateIterator.vala"
		g_value_set_boolean (value, gee_iterator_get_read_only ((GeeIterator*) self));
#line 22 "../src/DateIterator.vala"
		break;
#line 593 "DateIterator.c"
		default:
#line 22 "../src/DateIterator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/DateIterator.vala"
		break;
#line 599 "DateIterator.c"
	}
}

static void
_vala_util_date_iterator_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	UtilDateIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_ITERATOR, UtilDateIterator);
#line 22 "../src/DateIterator.vala"
	switch (property_id) {
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_CURRENT_PROPERTY:
#line 22 "../src/DateIterator.vala"
		util_date_iterator_set_current (self, g_value_get_boxed (value));
#line 22 "../src/DateIterator.vala"
		break;
#line 22 "../src/DateIterator.vala"
		case UTIL_DATE_ITERATOR_RANGE_PROPERTY:
#line 22 "../src/DateIterator.vala"
		util_date_iterator_set_range (self, g_value_get_object (value));
#line 22 "../src/DateIterator.vala"
		break;
#line 625 "DateIterator.c"
		default:
#line 22 "../src/DateIterator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/DateIterator.vala"
		break;
#line 631 "DateIterator.c"
	}
}

