/* ComponentRow.c generated by valac 0.56.18, the Vala compiler
 * generated from ComponentRow.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "datetime.h"
#include <glib.h>
#include <libical-glib/libical-glib.h>
#include <libedataserver/libedataserver.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DATE_TIME_COMPONENT_ROW_0_PROPERTY,
	DATE_TIME_COMPONENT_ROW_DATE_PROPERTY,
	DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY,
	DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY,
	DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY,
	DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY,
	DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY,
	DATE_TIME_COMPONENT_ROW_NUM_PROPERTIES
};
static GParamSpec* date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DateTimeComponentRowPrivate {
	GDateTime* _date;
	ICalComponent* _component;
	ESourceSelectable* _source_selectable;
	GDateTime* _start_time;
	GDateTime* _end_time;
	gboolean _is_allday;
	GtkGrid* grid;
	GtkImage* component_image;
	GtkLabel* name_label;
	GtkLabel* time_label;
};

static gint DateTimeComponentRow_private_offset;
static gpointer date_time_component_row_parent_class = NULL;
static DateTimeServicesTimeManager* date_time_component_row_time_manager;
static DateTimeServicesTimeManager* date_time_component_row_time_manager = NULL;
static GtkCssProvider* date_time_component_row_css_provider;
static GtkCssProvider* date_time_component_row_css_provider = NULL;

static void date_time_component_row_update_timelabel (DateTimeComponentRow* self);
static void date_time_component_row_set_color (DateTimeComponentRow* self);
static void date_time_component_row_set_start_time (DateTimeComponentRow* self,
                                             GDateTime* value);
static void date_time_component_row_set_end_time (DateTimeComponentRow* self,
                                           GDateTime* value);
static void date_time_component_row_set_is_allday (DateTimeComponentRow* self,
                                            gboolean value);
static GObject * date_time_component_row_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _date_time_component_row_set_color_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _date_time_component_row_update_timelabel_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void date_time_component_row_finalize (GObject * obj);
static GType date_time_component_row_get_type_once (void);
static void _vala_date_time_component_row_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_date_time_component_row_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
date_time_component_row_get_instance_private (DateTimeComponentRow* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeComponentRow_private_offset);
}

DateTimeComponentRow*
date_time_component_row_construct (GType object_type,
                                   GDateTime* date,
                                   ICalComponent* component,
                                   ESource* source)
{
	DateTimeComponentRow * self = NULL;
	ESourceSelectable* source_selectable = NULL;
	ESourceSelectable* _tmp2_;
#line 37 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 37 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (component != NULL, NULL);
#line 37 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 38 "../src/Widgets/ComponentRow.vala"
	source_selectable = NULL;
#line 40 "../src/Widgets/ComponentRow.vala"
	if (e_source_has_extension (source, E_SOURCE_EXTENSION_TASK_LIST)) {
#line 134 "ComponentRow.c"
		ESourceExtension* _tmp0_;
#line 41 "../src/Widgets/ComponentRow.vala"
		_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_TASK_LIST);
#line 41 "../src/Widgets/ComponentRow.vala"
		source_selectable = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_selectable_get_type (), ESourceSelectable);
#line 140 "ComponentRow.c"
	} else {
		ESourceExtension* _tmp1_;
#line 43 "../src/Widgets/ComponentRow.vala"
		_tmp1_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 43 "../src/Widgets/ComponentRow.vala"
		source_selectable = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_selectable_get_type (), ESourceSelectable);
#line 147 "ComponentRow.c"
	}
#line 46 "../src/Widgets/ComponentRow.vala"
	_tmp2_ = source_selectable;
#line 46 "../src/Widgets/ComponentRow.vala"
	self = (DateTimeComponentRow*) g_object_new (object_type, "component", component, "date", date, "source-selectable", _tmp2_, NULL);
#line 37 "../src/Widgets/ComponentRow.vala"
	return self;
#line 155 "ComponentRow.c"
}

DateTimeComponentRow*
date_time_component_row_new (GDateTime* date,
                             ICalComponent* component,
                             ESource* source)
{
#line 37 "../src/Widgets/ComponentRow.vala"
	return date_time_component_row_construct (DATE_TIME_TYPE_COMPONENT_ROW, date, component, source);
#line 165 "ComponentRow.c"
}

static void
date_time_component_row_update_timelabel (DateTimeComponentRow* self)
{
	gchar* time_format = NULL;
	DateTimeServicesTimeManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_;
	ESourceSelectable* _tmp4_;
#line 143 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = date_time_component_row_time_manager;
#line 144 "../src/Widgets/ComponentRow.vala"
	_tmp1_ = date_time_services_time_manager_get_is_12h (_tmp0_);
#line 144 "../src/Widgets/ComponentRow.vala"
	_tmp2_ = _tmp1_;
#line 144 "../src/Widgets/ComponentRow.vala"
	_tmp3_ = granite_date_time_get_default_time_format (_tmp2_, FALSE);
#line 144 "../src/Widgets/ComponentRow.vala"
	time_format = _tmp3_;
#line 145 "../src/Widgets/ComponentRow.vala"
	_tmp4_ = self->priv->_source_selectable;
#line 145 "../src/Widgets/ComponentRow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, e_source_task_list_get_type ())) {
#line 193 "ComponentRow.c"
		GtkLabel* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp5_ = self->priv->time_label;
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp6_ = self->priv->_start_time;
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp7_ = time_format;
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp9_ = _tmp8_;
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp10_ = g_strdup_printf ("<small>Due by %s</small>", _tmp9_);
#line 146 "../src/Widgets/ComponentRow.vala"
		_tmp11_ = _tmp10_;
#line 146 "../src/Widgets/ComponentRow.vala"
		gtk_label_set_label (_tmp5_, _tmp11_);
#line 146 "../src/Widgets/ComponentRow.vala"
		_g_free0 (_tmp11_);
#line 146 "../src/Widgets/ComponentRow.vala"
		_g_free0 (_tmp9_);
#line 221 "ComponentRow.c"
	} else {
		GtkLabel* _tmp12_;
		GDateTime* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GDateTime* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp12_ = self->priv->time_label;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp13_ = self->priv->_start_time;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp14_ = time_format;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp15_ = g_date_time_format (_tmp13_, _tmp14_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp16_ = _tmp15_;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp17_ = self->priv->_end_time;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp18_ = time_format;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp19_ = g_date_time_format (_tmp17_, _tmp18_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp20_ = _tmp19_;
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp21_ = g_strdup_printf ("<small>%s – %s</small>", _tmp16_, _tmp20_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_tmp22_ = _tmp21_;
#line 148 "../src/Widgets/ComponentRow.vala"
		gtk_label_set_label (_tmp12_, _tmp22_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_g_free0 (_tmp22_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_g_free0 (_tmp20_);
#line 148 "../src/Widgets/ComponentRow.vala"
		_g_free0 (_tmp16_);
#line 264 "ComponentRow.c"
	}
#line 143 "../src/Widgets/ComponentRow.vala"
	_g_free0 (time_format);
#line 268 "ComponentRow.c"
}

static void
date_time_component_row_set_color (DateTimeComponentRow* self)
{
	ESourceSelectable* _tmp0_;
	GtkGrid* _tmp1_;
	ESourceSelectable* _tmp2_;
	GtkImage* _tmp3_;
	ESourceSelectable* _tmp4_;
	GtkLabel* _tmp5_;
	ESourceSelectable* _tmp6_;
	GtkLabel* _tmp7_;
#line 152 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_source_selectable;
#line 153 "../src/Widgets/ComponentRow.vala"
	_tmp1_ = self->priv->grid;
#line 153 "../src/Widgets/ComponentRow.vala"
	util_set_component_calendar_color (_tmp0_, (GtkWidget*) _tmp1_);
#line 154 "../src/Widgets/ComponentRow.vala"
	_tmp2_ = self->priv->_source_selectable;
#line 154 "../src/Widgets/ComponentRow.vala"
	_tmp3_ = self->priv->component_image;
#line 154 "../src/Widgets/ComponentRow.vala"
	util_set_component_calendar_color (_tmp2_, (GtkWidget*) _tmp3_);
#line 155 "../src/Widgets/ComponentRow.vala"
	_tmp4_ = self->priv->_source_selectable;
#line 155 "../src/Widgets/ComponentRow.vala"
	_tmp5_ = self->priv->name_label;
#line 155 "../src/Widgets/ComponentRow.vala"
	util_set_component_calendar_color (_tmp4_, (GtkWidget*) _tmp5_);
#line 156 "../src/Widgets/ComponentRow.vala"
	_tmp6_ = self->priv->_source_selectable;
#line 156 "../src/Widgets/ComponentRow.vala"
	_tmp7_ = self->priv->time_label;
#line 156 "../src/Widgets/ComponentRow.vala"
	util_set_component_calendar_color (_tmp6_, (GtkWidget*) _tmp7_);
#line 308 "ComponentRow.c"
}

GDateTime*
date_time_component_row_get_date (DateTimeComponentRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 21 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_date;
#line 21 "../src/Widgets/ComponentRow.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/ComponentRow.vala"
	return result;
#line 324 "ComponentRow.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 21 "../src/Widgets/ComponentRow.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 332 "ComponentRow.c"
}

static void
date_time_component_row_set_date (DateTimeComponentRow* self,
                                  GDateTime* value)
{
	GDateTime* old_value;
#line 21 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_date (self);
#line 21 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 346 "ComponentRow.c"
		GDateTime* _tmp0_;
#line 21 "../src/Widgets/ComponentRow.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 21 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (self->priv->_date);
#line 21 "../src/Widgets/ComponentRow.vala"
		self->priv->_date = _tmp0_;
#line 21 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_DATE_PROPERTY]);
#line 356 "ComponentRow.c"
	}
}

ICalComponent*
date_time_component_row_get_component (DateTimeComponentRow* self)
{
	ICalComponent* result;
	ICalComponent* _tmp0_;
#line 22 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_component;
#line 22 "../src/Widgets/ComponentRow.vala"
	result = _tmp0_;
#line 22 "../src/Widgets/ComponentRow.vala"
	return result;
#line 373 "ComponentRow.c"
}

static void
date_time_component_row_set_component (DateTimeComponentRow* self,
                                       ICalComponent* value)
{
	ICalComponent* old_value;
#line 22 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_component (self);
#line 22 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/ComponentRow.vala"
		self->priv->_component = value;
#line 22 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY]);
#line 391 "ComponentRow.c"
	}
}

ESourceSelectable*
date_time_component_row_get_source_selectable (DateTimeComponentRow* self)
{
	ESourceSelectable* result;
	ESourceSelectable* _tmp0_;
#line 23 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_source_selectable;
#line 23 "../src/Widgets/ComponentRow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/ComponentRow.vala"
	return result;
#line 408 "ComponentRow.c"
}

static void
date_time_component_row_set_source_selectable (DateTimeComponentRow* self,
                                               ESourceSelectable* value)
{
	ESourceSelectable* old_value;
#line 23 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_source_selectable (self);
#line 23 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 23 "../src/Widgets/ComponentRow.vala"
		self->priv->_source_selectable = value;
#line 23 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY]);
#line 426 "ComponentRow.c"
	}
}

GDateTime*
date_time_component_row_get_start_time (DateTimeComponentRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 25 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_start_time;
#line 25 "../src/Widgets/ComponentRow.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/ComponentRow.vala"
	return result;
#line 443 "ComponentRow.c"
}

static void
date_time_component_row_set_start_time (DateTimeComponentRow* self,
                                        GDateTime* value)
{
	GDateTime* old_value;
#line 25 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_start_time (self);
#line 25 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 457 "ComponentRow.c"
		GDateTime* _tmp0_;
#line 25 "../src/Widgets/ComponentRow.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 25 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (self->priv->_start_time);
#line 25 "../src/Widgets/ComponentRow.vala"
		self->priv->_start_time = _tmp0_;
#line 25 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY]);
#line 467 "ComponentRow.c"
	}
}

GDateTime*
date_time_component_row_get_end_time (DateTimeComponentRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 26 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_end_time;
#line 26 "../src/Widgets/ComponentRow.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/ComponentRow.vala"
	return result;
#line 484 "ComponentRow.c"
}

static void
date_time_component_row_set_end_time (DateTimeComponentRow* self,
                                      GDateTime* value)
{
	GDateTime* old_value;
#line 26 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_end_time (self);
#line 26 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 498 "ComponentRow.c"
		GDateTime* _tmp0_;
#line 26 "../src/Widgets/ComponentRow.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 26 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (self->priv->_end_time);
#line 26 "../src/Widgets/ComponentRow.vala"
		self->priv->_end_time = _tmp0_;
#line 26 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY]);
#line 508 "ComponentRow.c"
	}
}

gboolean
date_time_component_row_get_is_allday (DateTimeComponentRow* self)
{
	gboolean result;
#line 27 "../src/Widgets/ComponentRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/Widgets/ComponentRow.vala"
	result = self->priv->_is_allday;
#line 27 "../src/Widgets/ComponentRow.vala"
	return result;
#line 522 "ComponentRow.c"
}

static void
date_time_component_row_set_is_allday (DateTimeComponentRow* self,
                                       gboolean value)
{
	gboolean old_value;
#line 27 "../src/Widgets/ComponentRow.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/ComponentRow.vala"
	old_value = date_time_component_row_get_is_allday (self);
#line 27 "../src/Widgets/ComponentRow.vala"
	if (old_value != value) {
#line 27 "../src/Widgets/ComponentRow.vala"
		self->priv->_is_allday = value;
#line 27 "../src/Widgets/ComponentRow.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY]);
#line 540 "ComponentRow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../src/Widgets/ComponentRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 549 "ComponentRow.c"
}

static void
_date_time_component_row_set_color_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 137 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_set_color ((DateTimeComponentRow*) self);
#line 559 "ComponentRow.c"
}

static void
_date_time_component_row_update_timelabel_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 140 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_update_timelabel ((DateTimeComponentRow*) self);
#line 569 "ComponentRow.c"
}

static GObject *
date_time_component_row_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DateTimeComponentRow * self;
	ICalTime* dt_start = NULL;
	ICalComponent* _tmp0_;
	ICalTime* _tmp1_;
	ICalTime* _tmp2_;
	ESourceSelectable* _tmp11_;
	gchar* icon_name = NULL;
	gchar* _tmp27_;
	ESourceSelectable* _tmp28_;
	const gchar* _tmp32_;
	GtkImage* _tmp33_ = NULL;
	GtkStyleContext* component_image_context = NULL;
	GtkImage* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkStyleContext* _tmp36_;
	GtkCssProvider* _tmp37_;
	ICalComponent* _tmp38_;
	const gchar* _tmp39_;
	GtkLabel* _tmp40_ = NULL;
	GtkStyleContext* name_label_context = NULL;
	GtkLabel* _tmp41_;
	GtkStyleContext* _tmp42_;
	GtkStyleContext* _tmp43_;
	GtkStyleContext* _tmp44_;
	GtkStyleContext* _tmp45_;
	GtkCssProvider* _tmp46_;
	GtkLabel* _tmp47_ = NULL;
	GtkLabel* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkGrid* _tmp50_ = NULL;
	GtkGrid* _tmp51_;
	GtkImage* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* _tmp54_;
	gboolean _tmp55_;
	GtkStyleContext* grid_context = NULL;
	GtkGrid* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkStyleContext* _tmp60_;
	GtkStyleContext* _tmp61_;
	GtkCssProvider* _tmp62_;
	GtkGrid* _tmp63_;
	ESourceSelectable* _tmp64_;
	DateTimeServicesTimeManager* _tmp65_;
#line 60 "../src/Widgets/ComponentRow.vala"
	parent_class = G_OBJECT_CLASS (date_time_component_row_parent_class);
#line 60 "../src/Widgets/ComponentRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../src/Widgets/ComponentRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_COMPONENT_ROW, DateTimeComponentRow);
#line 61 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = self->priv->_component;
#line 61 "../src/Widgets/ComponentRow.vala"
	_tmp1_ = i_cal_component_get_dtstart (_tmp0_);
#line 61 "../src/Widgets/ComponentRow.vala"
	dt_start = _tmp1_;
#line 62 "../src/Widgets/ComponentRow.vala"
	_tmp2_ = dt_start;
#line 62 "../src/Widgets/ComponentRow.vala"
	if (i_cal_time_is_date (_tmp2_)) {
#line 639 "ComponentRow.c"
		ICalTime* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 64 "../src/Widgets/ComponentRow.vala"
		_tmp3_ = dt_start;
#line 64 "../src/Widgets/ComponentRow.vala"
		_tmp4_ = util_ical_to_date_time (_tmp3_);
#line 64 "../src/Widgets/ComponentRow.vala"
		_tmp5_ = _tmp4_;
#line 64 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_start_time (self, _tmp5_);
#line 64 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (_tmp5_);
#line 653 "ComponentRow.c"
	} else {
		ICalTime* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
#line 66 "../src/Widgets/ComponentRow.vala"
		_tmp6_ = dt_start;
#line 66 "../src/Widgets/ComponentRow.vala"
		_tmp7_ = util_ical_to_date_time (_tmp6_);
#line 66 "../src/Widgets/ComponentRow.vala"
		_tmp8_ = _tmp7_;
#line 66 "../src/Widgets/ComponentRow.vala"
		_tmp9_ = g_date_time_to_local (_tmp8_);
#line 66 "../src/Widgets/ComponentRow.vala"
		_tmp10_ = _tmp9_;
#line 66 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_start_time (self, _tmp10_);
#line 66 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (_tmp10_);
#line 66 "../src/Widgets/ComponentRow.vala"
		_g_date_time_unref0 (_tmp8_);
#line 676 "ComponentRow.c"
	}
#line 69 "../src/Widgets/ComponentRow.vala"
	_tmp11_ = self->priv->_source_selectable;
#line 69 "../src/Widgets/ComponentRow.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, e_source_task_list_get_type ())) {
#line 682 "ComponentRow.c"
		ICalTime* dt_end = NULL;
		ICalComponent* _tmp12_;
		ICalTime* _tmp13_;
		ICalTime* _tmp14_;
		gboolean _tmp23_ = FALSE;
		GDateTime* _tmp24_;
#line 70 "../src/Widgets/ComponentRow.vala"
		_tmp12_ = self->priv->_component;
#line 70 "../src/Widgets/ComponentRow.vala"
		_tmp13_ = i_cal_component_get_dtend (_tmp12_);
#line 70 "../src/Widgets/ComponentRow.vala"
		dt_end = _tmp13_;
#line 71 "../src/Widgets/ComponentRow.vala"
		_tmp14_ = dt_end;
#line 71 "../src/Widgets/ComponentRow.vala"
		if (i_cal_time_is_date (_tmp14_)) {
#line 699 "ComponentRow.c"
			ICalTime* _tmp15_;
			GDateTime* _tmp16_;
			GDateTime* _tmp17_;
#line 73 "../src/Widgets/ComponentRow.vala"
			_tmp15_ = dt_end;
#line 73 "../src/Widgets/ComponentRow.vala"
			_tmp16_ = util_ical_to_date_time (_tmp15_);
#line 73 "../src/Widgets/ComponentRow.vala"
			_tmp17_ = _tmp16_;
#line 73 "../src/Widgets/ComponentRow.vala"
			date_time_component_row_set_end_time (self, _tmp17_);
#line 73 "../src/Widgets/ComponentRow.vala"
			_g_date_time_unref0 (_tmp17_);
#line 713 "ComponentRow.c"
		} else {
			ICalTime* _tmp18_;
			GDateTime* _tmp19_;
			GDateTime* _tmp20_;
			GDateTime* _tmp21_;
			GDateTime* _tmp22_;
#line 75 "../src/Widgets/ComponentRow.vala"
			_tmp18_ = dt_end;
#line 75 "../src/Widgets/ComponentRow.vala"
			_tmp19_ = util_ical_to_date_time (_tmp18_);
#line 75 "../src/Widgets/ComponentRow.vala"
			_tmp20_ = _tmp19_;
#line 75 "../src/Widgets/ComponentRow.vala"
			_tmp21_ = g_date_time_to_local (_tmp20_);
#line 75 "../src/Widgets/ComponentRow.vala"
			_tmp22_ = _tmp21_;
#line 75 "../src/Widgets/ComponentRow.vala"
			date_time_component_row_set_end_time (self, _tmp22_);
#line 75 "../src/Widgets/ComponentRow.vala"
			_g_date_time_unref0 (_tmp22_);
#line 75 "../src/Widgets/ComponentRow.vala"
			_g_date_time_unref0 (_tmp20_);
#line 736 "ComponentRow.c"
		}
#line 78 "../src/Widgets/ComponentRow.vala"
		_tmp24_ = self->priv->_end_time;
#line 78 "../src/Widgets/ComponentRow.vala"
		if (_tmp24_ != NULL) {
#line 742 "ComponentRow.c"
			GDateTime* _tmp25_;
			GDateTime* _tmp26_;
#line 78 "../src/Widgets/ComponentRow.vala"
			_tmp25_ = self->priv->_start_time;
#line 78 "../src/Widgets/ComponentRow.vala"
			_tmp26_ = self->priv->_end_time;
#line 78 "../src/Widgets/ComponentRow.vala"
			_tmp23_ = util_is_the_all_day (_tmp25_, _tmp26_);
#line 751 "ComponentRow.c"
		} else {
#line 78 "../src/Widgets/ComponentRow.vala"
			_tmp23_ = FALSE;
#line 755 "ComponentRow.c"
		}
#line 78 "../src/Widgets/ComponentRow.vala"
		if (_tmp23_) {
#line 79 "../src/Widgets/ComponentRow.vala"
			date_time_component_row_set_is_allday (self, TRUE);
#line 761 "ComponentRow.c"
		}
#line 69 "../src/Widgets/ComponentRow.vala"
		_g_object_unref0 (dt_end);
#line 765 "ComponentRow.c"
	}
#line 83 "../src/Widgets/ComponentRow.vala"
	_tmp27_ = g_strdup ("office-calendar-symbolic");
#line 83 "../src/Widgets/ComponentRow.vala"
	icon_name = _tmp27_;
#line 84 "../src/Widgets/ComponentRow.vala"
	_tmp28_ = self->priv->_source_selectable;
#line 84 "../src/Widgets/ComponentRow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, e_source_task_list_get_type ())) {
#line 775 "ComponentRow.c"
		gchar* _tmp29_;
#line 85 "../src/Widgets/ComponentRow.vala"
		_tmp29_ = g_strdup ("office-task-symbolic");
#line 85 "../src/Widgets/ComponentRow.vala"
		_g_free0 (icon_name);
#line 85 "../src/Widgets/ComponentRow.vala"
		icon_name = _tmp29_;
#line 783 "ComponentRow.c"
	} else {
		GDateTime* _tmp30_;
#line 86 "../src/Widgets/ComponentRow.vala"
		_tmp30_ = self->priv->_end_time;
#line 86 "../src/Widgets/ComponentRow.vala"
		if (_tmp30_ == NULL) {
#line 790 "ComponentRow.c"
			gchar* _tmp31_;
#line 87 "../src/Widgets/ComponentRow.vala"
			_tmp31_ = g_strdup ("alarm-symbolic");
#line 87 "../src/Widgets/ComponentRow.vala"
			_g_free0 (icon_name);
#line 87 "../src/Widgets/ComponentRow.vala"
			icon_name = _tmp31_;
#line 798 "ComponentRow.c"
		}
	}
#line 90 "../src/Widgets/ComponentRow.vala"
	_tmp32_ = icon_name;
#line 90 "../src/Widgets/ComponentRow.vala"
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp32_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 90 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_START);
#line 90 "../src/Widgets/ComponentRow.vala"
	g_object_ref_sink (_tmp33_);
#line 90 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->component_image);
#line 90 "../src/Widgets/ComponentRow.vala"
	self->priv->component_image = _tmp33_;
#line 94 "../src/Widgets/ComponentRow.vala"
	_tmp34_ = self->priv->component_image;
#line 94 "../src/Widgets/ComponentRow.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 94 "../src/Widgets/ComponentRow.vala"
	component_image_context = _tmp35_;
#line 95 "../src/Widgets/ComponentRow.vala"
	_tmp36_ = component_image_context;
#line 95 "../src/Widgets/ComponentRow.vala"
	_tmp37_ = date_time_component_row_css_provider;
#line 95 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_provider (_tmp36_, (GtkStyleProvider*) _tmp37_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 97 "../src/Widgets/ComponentRow.vala"
	_tmp38_ = self->priv->_component;
#line 97 "../src/Widgets/ComponentRow.vala"
	_tmp39_ = i_cal_component_get_summary (_tmp38_);
#line 97 "../src/Widgets/ComponentRow.vala"
	_tmp40_ = (GtkLabel*) gtk_label_new (_tmp39_);
#line 97 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp40_, TRUE);
#line 97 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_ellipsize (_tmp40_, PANGO_ELLIPSIZE_END);
#line 97 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_lines (_tmp40_, 3);
#line 97 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_max_width_chars (_tmp40_, 30);
#line 97 "../src/Widgets/ComponentRow.vala"
	g_object_set (_tmp40_, "wrap", TRUE, NULL);
#line 97 "../src/Widgets/ComponentRow.vala"
	g_object_set (_tmp40_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 97 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_xalign (_tmp40_, (gfloat) 0);
#line 97 "../src/Widgets/ComponentRow.vala"
	g_object_ref_sink (_tmp40_);
#line 97 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->name_label);
#line 97 "../src/Widgets/ComponentRow.vala"
	self->priv->name_label = _tmp40_;
#line 107 "../src/Widgets/ComponentRow.vala"
	_tmp41_ = self->priv->name_label;
#line 107 "../src/Widgets/ComponentRow.vala"
	_tmp42_ = gtk_widget_get_style_context ((GtkWidget*) _tmp41_);
#line 107 "../src/Widgets/ComponentRow.vala"
	_tmp43_ = _g_object_ref0 (_tmp42_);
#line 107 "../src/Widgets/ComponentRow.vala"
	name_label_context = _tmp43_;
#line 108 "../src/Widgets/ComponentRow.vala"
	_tmp44_ = name_label_context;
#line 108 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_class (_tmp44_, "title");
#line 109 "../src/Widgets/ComponentRow.vala"
	_tmp45_ = name_label_context;
#line 109 "../src/Widgets/ComponentRow.vala"
	_tmp46_ = date_time_component_row_css_provider;
#line 109 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_provider (_tmp45_, (GtkStyleProvider*) _tmp46_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 111 "../src/Widgets/ComponentRow.vala"
	_tmp47_ = (GtkLabel*) gtk_label_new (NULL);
#line 111 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_use_markup (_tmp47_, TRUE);
#line 111 "../src/Widgets/ComponentRow.vala"
	gtk_label_set_xalign (_tmp47_, (gfloat) 0);
#line 111 "../src/Widgets/ComponentRow.vala"
	g_object_ref_sink (_tmp47_);
#line 111 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->time_label);
#line 111 "../src/Widgets/ComponentRow.vala"
	self->priv->time_label = _tmp47_;
#line 115 "../src/Widgets/ComponentRow.vala"
	_tmp48_ = self->priv->time_label;
#line 115 "../src/Widgets/ComponentRow.vala"
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
#line 115 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_class (_tmp49_, GTK_STYLE_CLASS_DIM_LABEL);
#line 117 "../src/Widgets/ComponentRow.vala"
	_tmp50_ = (GtkGrid*) gtk_grid_new ();
#line 117 "../src/Widgets/ComponentRow.vala"
	gtk_grid_set_column_spacing (_tmp50_, 6);
#line 117 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp50_, 3);
#line 117 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp50_, 3);
#line 117 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp50_, 6);
#line 117 "../src/Widgets/ComponentRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp50_, 6);
#line 117 "../src/Widgets/ComponentRow.vala"
	g_object_ref_sink (_tmp50_);
#line 117 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->grid);
#line 117 "../src/Widgets/ComponentRow.vala"
	self->priv->grid = _tmp50_;
#line 124 "../src/Widgets/ComponentRow.vala"
	_tmp51_ = self->priv->grid;
#line 124 "../src/Widgets/ComponentRow.vala"
	_tmp52_ = self->priv->component_image;
#line 124 "../src/Widgets/ComponentRow.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 0, 1, 1);
#line 125 "../src/Widgets/ComponentRow.vala"
	_tmp53_ = self->priv->grid;
#line 125 "../src/Widgets/ComponentRow.vala"
	_tmp54_ = self->priv->name_label;
#line 125 "../src/Widgets/ComponentRow.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 1, 0, 1, 1);
#line 126 "../src/Widgets/ComponentRow.vala"
	_tmp55_ = self->priv->_is_allday;
#line 126 "../src/Widgets/ComponentRow.vala"
	if (!_tmp55_) {
#line 921 "ComponentRow.c"
		GtkGrid* _tmp56_;
		GtkLabel* _tmp57_;
#line 127 "../src/Widgets/ComponentRow.vala"
		_tmp56_ = self->priv->grid;
#line 127 "../src/Widgets/ComponentRow.vala"
		_tmp57_ = self->priv->time_label;
#line 127 "../src/Widgets/ComponentRow.vala"
		gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 1, 1, 1, 1);
#line 930 "ComponentRow.c"
	}
#line 130 "../src/Widgets/ComponentRow.vala"
	_tmp58_ = self->priv->grid;
#line 130 "../src/Widgets/ComponentRow.vala"
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
#line 130 "../src/Widgets/ComponentRow.vala"
	grid_context = _tmp59_;
#line 131 "../src/Widgets/ComponentRow.vala"
	_tmp60_ = grid_context;
#line 131 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_class (_tmp60_, "event");
#line 132 "../src/Widgets/ComponentRow.vala"
	_tmp61_ = grid_context;
#line 132 "../src/Widgets/ComponentRow.vala"
	_tmp62_ = date_time_component_row_css_provider;
#line 132 "../src/Widgets/ComponentRow.vala"
	gtk_style_context_add_provider (_tmp61_, (GtkStyleProvider*) _tmp62_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 134 "../src/Widgets/ComponentRow.vala"
	_tmp63_ = self->priv->grid;
#line 134 "../src/Widgets/ComponentRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp63_);
#line 136 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_set_color (self);
#line 137 "../src/Widgets/ComponentRow.vala"
	_tmp64_ = self->priv->_source_selectable;
#line 137 "../src/Widgets/ComponentRow.vala"
	g_signal_connect_object ((GObject*) _tmp64_, "notify::color", (GCallback) _date_time_component_row_set_color_g_object_notify, self, 0);
#line 139 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_update_timelabel (self);
#line 140 "../src/Widgets/ComponentRow.vala"
	_tmp65_ = date_time_component_row_time_manager;
#line 140 "../src/Widgets/ComponentRow.vala"
	g_signal_connect_object ((GObject*) _tmp65_, "notify::is-12h", (GCallback) _date_time_component_row_update_timelabel_g_object_notify, self, 0);
#line 60 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (name_label_context);
#line 60 "../src/Widgets/ComponentRow.vala"
	_g_free0 (icon_name);
#line 60 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (dt_start);
#line 60 "../src/Widgets/ComponentRow.vala"
	return obj;
#line 972 "ComponentRow.c"
}

static void
date_time_component_row_class_init (DateTimeComponentRowClass * klass,
                                    gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	DateTimeServicesTimeManager* _tmp2_;
#line 20 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/ComponentRow.vala"
	g_type_class_adjust_private_offset (klass, &DateTimeComponentRow_private_offset);
#line 20 "../src/Widgets/ComponentRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_component_row_get_property;
#line 20 "../src/Widgets/ComponentRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_component_row_set_property;
#line 20 "../src/Widgets/ComponentRow.vala"
	G_OBJECT_CLASS (klass)->constructor = date_time_component_row_constructor;
#line 20 "../src/Widgets/ComponentRow.vala"
	G_OBJECT_CLASS (klass)->finalize = date_time_component_row_finalize;
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_DATE_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY] = g_param_spec_object ("component", "component", "component", i_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY] = g_param_spec_object ("source-selectable", "source-selectable", "source-selectable", e_source_selectable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY] = g_param_spec_boxed ("start-time", "start-time", "start-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY] = g_param_spec_boxed ("end-time", "end-time", "end-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Widgets/ComponentRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY, date_time_component_row_properties[DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY] = g_param_spec_boolean ("is-allday", "is-allday", "is-allday", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 54 "../src/Widgets/ComponentRow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 54 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (date_time_component_row_css_provider);
#line 54 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_css_provider = _tmp0_;
#line 55 "../src/Widgets/ComponentRow.vala"
	_tmp1_ = date_time_component_row_css_provider;
#line 55 "../src/Widgets/ComponentRow.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/desktop/wingpanel/datetime/EventRow.css");
#line 57 "../src/Widgets/ComponentRow.vala"
	_tmp2_ = date_time_services_time_manager_get_default ();
#line 57 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (date_time_component_row_time_manager);
#line 57 "../src/Widgets/ComponentRow.vala"
	date_time_component_row_time_manager = _tmp2_;
#line 1022 "ComponentRow.c"
}

static void
date_time_component_row_instance_init (DateTimeComponentRow * self,
                                       gpointer klass)
{
#line 20 "../src/Widgets/ComponentRow.vala"
	self->priv = date_time_component_row_get_instance_private (self);
#line 27 "../src/Widgets/ComponentRow.vala"
	self->priv->_is_allday = FALSE;
#line 1033 "ComponentRow.c"
}

static void
date_time_component_row_finalize (GObject * obj)
{
	DateTimeComponentRow * self;
#line 20 "../src/Widgets/ComponentRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_COMPONENT_ROW, DateTimeComponentRow);
#line 21 "../src/Widgets/ComponentRow.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 25 "../src/Widgets/ComponentRow.vala"
	_g_date_time_unref0 (self->priv->_start_time);
#line 26 "../src/Widgets/ComponentRow.vala"
	_g_date_time_unref0 (self->priv->_end_time);
#line 32 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->grid);
#line 33 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->component_image);
#line 34 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->name_label);
#line 35 "../src/Widgets/ComponentRow.vala"
	_g_object_unref0 (self->priv->time_label);
#line 20 "../src/Widgets/ComponentRow.vala"
	G_OBJECT_CLASS (date_time_component_row_parent_class)->finalize (obj);
#line 1058 "ComponentRow.c"
}

static GType
date_time_component_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeComponentRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_component_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeComponentRow), 0, (GInstanceInitFunc) date_time_component_row_instance_init, NULL };
	GType date_time_component_row_type_id;
	date_time_component_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DateTimeComponentRow", &g_define_type_info, 0);
	DateTimeComponentRow_private_offset = g_type_add_instance_private (date_time_component_row_type_id, sizeof (DateTimeComponentRowPrivate));
	return date_time_component_row_type_id;
}

GType
date_time_component_row_get_type (void)
{
	static volatile gsize date_time_component_row_type_id__once = 0;
	if (g_once_init_enter (&date_time_component_row_type_id__once)) {
		GType date_time_component_row_type_id;
		date_time_component_row_type_id = date_time_component_row_get_type_once ();
		g_once_init_leave (&date_time_component_row_type_id__once, date_time_component_row_type_id);
	}
	return date_time_component_row_type_id__once;
}

static void
_vala_date_time_component_row_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DateTimeComponentRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_COMPONENT_ROW, DateTimeComponentRow);
#line 20 "../src/Widgets/ComponentRow.vala"
	switch (property_id) {
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_DATE_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_boxed (value, date_time_component_row_get_date (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_object (value, date_time_component_row_get_component (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_object (value, date_time_component_row_get_source_selectable (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_boxed (value, date_time_component_row_get_start_time (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_boxed (value, date_time_component_row_get_end_time (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		g_value_set_boolean (value, date_time_component_row_get_is_allday (self));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 1129 "ComponentRow.c"
		default:
#line 20 "../src/Widgets/ComponentRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 1135 "ComponentRow.c"
	}
}

static void
_vala_date_time_component_row_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DateTimeComponentRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_COMPONENT_ROW, DateTimeComponentRow);
#line 20 "../src/Widgets/ComponentRow.vala"
	switch (property_id) {
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_DATE_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_date (self, g_value_get_boxed (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_COMPONENT_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_component (self, g_value_get_object (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_SOURCE_SELECTABLE_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_source_selectable (self, g_value_get_object (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_START_TIME_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_start_time (self, g_value_get_boxed (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_END_TIME_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_end_time (self, g_value_get_boxed (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 20 "../src/Widgets/ComponentRow.vala"
		case DATE_TIME_COMPONENT_ROW_IS_ALLDAY_PROPERTY:
#line 20 "../src/Widgets/ComponentRow.vala"
		date_time_component_row_set_is_allday (self, g_value_get_boolean (value));
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 1185 "ComponentRow.c"
		default:
#line 20 "../src/Widgets/ComponentRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/ComponentRow.vala"
		break;
#line 1191 "ComponentRow.c"
	}
}

