/* Grid.c generated by valac 0.56.18, the Vala compiler
 * generated from Grid.vala, do not modify */

/*
 * Copyright 2011–2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Maxwell Barvian
 *              Corentin Noël <corentin@elementaryos.org>
 */

#include "datetime.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <libical-glib/libical-glib.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DATE_TIME_WIDGETS_GRID_0_PROPERTY,
	DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY,
	DATE_TIME_WIDGETS_GRID_NUM_PROPERTIES
};
static GParamSpec* date_time_widgets_grid_properties[DATE_TIME_WIDGETS_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
enum  {
	DATE_TIME_WIDGETS_GRID_ON_EVENT_ADD_SIGNAL,
	DATE_TIME_WIDGETS_GRID_SELECTION_CHANGED_SIGNAL,
	DATE_TIME_WIDGETS_GRID_NUM_SIGNALS
};
static guint date_time_widgets_grid_signals[DATE_TIME_WIDGETS_GRID_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DateTimeWidgetsGridPrivate {
	UtilDateRange* _grid_range;
	GeeHashMap* data;
	DateTimeWidgetsGridDay* selected_gridday;
	GtkLabel** header_labels;
	gint header_labels_length1;
	gint _header_labels_size_;
	GtkRevealer** week_labels;
	gint week_labels_length1;
	gint _week_labels_size_;
};

struct _Block8Data {
	int _ref_count_;
	DateTimeWidgetsGrid* self;
	DateTimeWidgetsGridDay* day;
};

static gint DateTimeWidgetsGrid_private_offset;
static gpointer date_time_widgets_grid_parent_class = NULL;
static DateTimeWidgetsCalendarModel* date_time_widgets_grid_events_model;
static DateTimeWidgetsCalendarModel* date_time_widgets_grid_events_model = NULL;
static DateTimeWidgetsCalendarModel* date_time_widgets_grid_tasks_model;
static DateTimeWidgetsCalendarModel* date_time_widgets_grid_tasks_model = NULL;

static void date_time_widgets_grid_add_component_dots (DateTimeWidgetsGrid* self,
                                                ESource* source,
                                                GeeCollection* components);
static guint date_time_widgets_grid_day_hash (DateTimeWidgetsGrid* self,
                                       GDateTime* date);
static void date_time_widgets_grid_remove_component_dots (DateTimeWidgetsGrid* self,
                                                   ESource* source,
                                                   GeeCollection* components);
static void date_time_widgets_grid_on_day_focus_in (DateTimeWidgetsGrid* self,
                                             DateTimeWidgetsGridDay* day);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static DateTimeWidgetsGridDay* date_time_widgets_grid_update_day (DateTimeWidgetsGrid* self,
                                                           DateTimeWidgetsGridDay* day,
                                                           GDateTime* new_date,
                                                           GDateTime* today,
                                                           GDateTime* month_start);
static void _____lambda23_ (DateTimeWidgetsGrid* self,
                     GDateTime* date);
static void ______lambda23__date_time_widgets_grid_day_on_event_add (DateTimeWidgetsGridDay* _sender,
                                                              GDateTime* date,
                                                              gpointer self);
static gboolean _____lambda24_ (Block8Data* _data8_,
                         GdkEventFocus* event);
static gboolean ______lambda24__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self);
static void date_time_widgets_grid_set_grid_range (DateTimeWidgetsGrid* self,
                                            UtilDateRange* value);
static void date_time_widgets_grid_update_today_style (DateTimeWidgetsGrid* self,
                                                DateTimeWidgetsGridDay* day,
                                                GDateTime* date,
                                                GDateTime* today);
static GObject * date_time_widgets_grid_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _date_time_widgets_grid_add_component_dots_date_time_widgets_calendar_model_components_added (DateTimeWidgetsCalendarModel* _sender,
                                                                                                   ESource* source,
                                                                                                   GeeCollection* components,
                                                                                                   gpointer self);
static void _date_time_widgets_grid_remove_component_dots_date_time_widgets_calendar_model_components_removed (DateTimeWidgetsCalendarModel* _sender,
                                                                                                        ESource* source,
                                                                                                        GeeCollection* components,
                                                                                                        gpointer self);
static void date_time_widgets_grid_finalize (GObject * obj);
static GType date_time_widgets_grid_get_type_once (void);
static void _vala_date_time_widgets_grid_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_date_time_widgets_grid_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
date_time_widgets_grid_get_instance_private (DateTimeWidgetsGrid* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeWidgetsGrid_private_offset);
}

static void
date_time_widgets_grid_add_component_dots (DateTimeWidgetsGrid* self,
                                           ESource* source,
                                           GeeCollection* components)
{
#line 83 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (source != NULL);
#line 83 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (components != NULL);
#line 175 "Grid.c"
	{
		GeeIterator* _component_it = NULL;
		GeeIterator* _tmp0_;
#line 84 "../src/Widgets/calendar/Grid.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) components);
#line 84 "../src/Widgets/calendar/Grid.vala"
		_component_it = _tmp0_;
#line 84 "../src/Widgets/calendar/Grid.vala"
		while (TRUE) {
#line 185 "Grid.c"
			GeeIterator* _tmp1_;
			ECalComponent* component = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ICalComponent* ical = NULL;
			ECalComponent* _tmp4_;
			ICalComponent* _tmp5_;
			time_t start_time = 0;
			ICalComponent* _tmp6_;
			ICalTime* _tmp7_;
			ICalTime* _tmp8_;
			time_t _tmp9_;
			GDateTime* date_time = NULL;
			GDateTime* _tmp10_;
			guint date_hash = 0U;
			GDateTime* _tmp11_;
			GeeHashMap* _tmp12_;
#line 84 "../src/Widgets/calendar/Grid.vala"
			_tmp1_ = _component_it;
#line 84 "../src/Widgets/calendar/Grid.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 84 "../src/Widgets/calendar/Grid.vala"
				break;
#line 209 "Grid.c"
			}
#line 84 "../src/Widgets/calendar/Grid.vala"
			_tmp2_ = _component_it;
#line 84 "../src/Widgets/calendar/Grid.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 84 "../src/Widgets/calendar/Grid.vala"
			component = (ECalComponent*) _tmp3_;
#line 85 "../src/Widgets/calendar/Grid.vala"
			_tmp4_ = component;
#line 85 "../src/Widgets/calendar/Grid.vala"
			_tmp5_ = e_cal_component_get_icalcomponent (_tmp4_);
#line 85 "../src/Widgets/calendar/Grid.vala"
			ical = _tmp5_;
#line 87 "../src/Widgets/calendar/Grid.vala"
			_tmp6_ = ical;
#line 87 "../src/Widgets/calendar/Grid.vala"
			_tmp7_ = i_cal_component_get_dtstart (_tmp6_);
#line 87 "../src/Widgets/calendar/Grid.vala"
			_tmp8_ = _tmp7_;
#line 87 "../src/Widgets/calendar/Grid.vala"
			_tmp9_ = i_cal_time_as_timet (_tmp8_);
#line 87 "../src/Widgets/calendar/Grid.vala"
			_g_object_unref0 (_tmp8_);
#line 87 "../src/Widgets/calendar/Grid.vala"
			start_time = _tmp9_;
#line 88 "../src/Widgets/calendar/Grid.vala"
			_tmp10_ = g_date_time_new_from_unix_utc ((gint64) start_time);
#line 88 "../src/Widgets/calendar/Grid.vala"
			date_time = _tmp10_;
#line 89 "../src/Widgets/calendar/Grid.vala"
			_tmp11_ = date_time;
#line 89 "../src/Widgets/calendar/Grid.vala"
			date_hash = date_time_widgets_grid_day_hash (self, _tmp11_);
#line 91 "../src/Widgets/calendar/Grid.vala"
			_tmp12_ = self->priv->data;
#line 91 "../src/Widgets/calendar/Grid.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp12_, (gpointer) ((guintptr) date_hash))) {
#line 247 "Grid.c"
				GeeHashMap* _tmp13_;
				gpointer _tmp14_;
				DateTimeWidgetsGridDay* _tmp15_;
				ICalComponent* _tmp16_;
#line 92 "../src/Widgets/calendar/Grid.vala"
				_tmp13_ = self->priv->data;
#line 92 "../src/Widgets/calendar/Grid.vala"
				_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp13_, (gpointer) ((guintptr) date_hash));
#line 92 "../src/Widgets/calendar/Grid.vala"
				_tmp15_ = (DateTimeWidgetsGridDay*) _tmp14_;
#line 92 "../src/Widgets/calendar/Grid.vala"
				_tmp16_ = ical;
#line 92 "../src/Widgets/calendar/Grid.vala"
				date_time_widgets_grid_day_add_component_dot (_tmp15_, source, _tmp16_);
#line 92 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp15_);
#line 264 "Grid.c"
			}
#line 84 "../src/Widgets/calendar/Grid.vala"
			_g_date_time_unref0 (date_time);
#line 84 "../src/Widgets/calendar/Grid.vala"
			_g_object_unref0 (component);
#line 270 "Grid.c"
		}
#line 84 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (_component_it);
#line 274 "Grid.c"
	}
#line 96 "../src/Widgets/calendar/Grid.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 278 "Grid.c"
}

static void
date_time_widgets_grid_remove_component_dots (DateTimeWidgetsGrid* self,
                                              ESource* source,
                                              GeeCollection* components)
{
#line 99 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (source != NULL);
#line 99 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (components != NULL);
#line 292 "Grid.c"
	{
		GeeIterator* _component_it = NULL;
		GeeIterator* _tmp0_;
#line 100 "../src/Widgets/calendar/Grid.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) components);
#line 100 "../src/Widgets/calendar/Grid.vala"
		_component_it = _tmp0_;
#line 100 "../src/Widgets/calendar/Grid.vala"
		while (TRUE) {
#line 302 "Grid.c"
			GeeIterator* _tmp1_;
			ECalComponent* component = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ICalComponent* ical = NULL;
			ECalComponent* _tmp4_;
			ICalComponent* _tmp5_;
			time_t start_time = 0;
			ICalComponent* _tmp6_;
			ICalTime* _tmp7_;
			ICalTime* _tmp8_;
			time_t _tmp9_;
			GDateTime* date_time = NULL;
			GDateTime* _tmp10_;
			guint date_hash = 0U;
			GDateTime* _tmp11_;
			GeeHashMap* _tmp12_;
#line 100 "../src/Widgets/calendar/Grid.vala"
			_tmp1_ = _component_it;
#line 100 "../src/Widgets/calendar/Grid.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 100 "../src/Widgets/calendar/Grid.vala"
				break;
#line 326 "Grid.c"
			}
#line 100 "../src/Widgets/calendar/Grid.vala"
			_tmp2_ = _component_it;
#line 100 "../src/Widgets/calendar/Grid.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 100 "../src/Widgets/calendar/Grid.vala"
			component = (ECalComponent*) _tmp3_;
#line 101 "../src/Widgets/calendar/Grid.vala"
			_tmp4_ = component;
#line 101 "../src/Widgets/calendar/Grid.vala"
			_tmp5_ = e_cal_component_get_icalcomponent (_tmp4_);
#line 101 "../src/Widgets/calendar/Grid.vala"
			ical = _tmp5_;
#line 103 "../src/Widgets/calendar/Grid.vala"
			_tmp6_ = ical;
#line 103 "../src/Widgets/calendar/Grid.vala"
			_tmp7_ = i_cal_component_get_dtstart (_tmp6_);
#line 103 "../src/Widgets/calendar/Grid.vala"
			_tmp8_ = _tmp7_;
#line 103 "../src/Widgets/calendar/Grid.vala"
			_tmp9_ = i_cal_time_as_timet (_tmp8_);
#line 103 "../src/Widgets/calendar/Grid.vala"
			_g_object_unref0 (_tmp8_);
#line 103 "../src/Widgets/calendar/Grid.vala"
			start_time = _tmp9_;
#line 104 "../src/Widgets/calendar/Grid.vala"
			_tmp10_ = g_date_time_new_from_unix_utc ((gint64) start_time);
#line 104 "../src/Widgets/calendar/Grid.vala"
			date_time = _tmp10_;
#line 105 "../src/Widgets/calendar/Grid.vala"
			_tmp11_ = date_time;
#line 105 "../src/Widgets/calendar/Grid.vala"
			date_hash = date_time_widgets_grid_day_hash (self, _tmp11_);
#line 107 "../src/Widgets/calendar/Grid.vala"
			_tmp12_ = self->priv->data;
#line 107 "../src/Widgets/calendar/Grid.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp12_, (gpointer) ((guintptr) date_hash))) {
#line 364 "Grid.c"
				gchar* component_uid = NULL;
				ICalComponent* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				GeeHashMap* _tmp16_;
				gpointer _tmp17_;
				DateTimeWidgetsGridDay* _tmp18_;
				const gchar* _tmp19_;
#line 108 "../src/Widgets/calendar/Grid.vala"
				_tmp13_ = ical;
#line 108 "../src/Widgets/calendar/Grid.vala"
				_tmp14_ = i_cal_component_get_uid (_tmp13_);
#line 108 "../src/Widgets/calendar/Grid.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 108 "../src/Widgets/calendar/Grid.vala"
				component_uid = _tmp15_;
#line 109 "../src/Widgets/calendar/Grid.vala"
				_tmp16_ = self->priv->data;
#line 109 "../src/Widgets/calendar/Grid.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, (gpointer) ((guintptr) date_hash));
#line 109 "../src/Widgets/calendar/Grid.vala"
				_tmp18_ = (DateTimeWidgetsGridDay*) _tmp17_;
#line 109 "../src/Widgets/calendar/Grid.vala"
				_tmp19_ = component_uid;
#line 109 "../src/Widgets/calendar/Grid.vala"
				date_time_widgets_grid_day_remove_component_dot (_tmp18_, _tmp19_);
#line 109 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp18_);
#line 107 "../src/Widgets/calendar/Grid.vala"
				_g_free0 (component_uid);
#line 395 "Grid.c"
			}
#line 100 "../src/Widgets/calendar/Grid.vala"
			_g_date_time_unref0 (date_time);
#line 100 "../src/Widgets/calendar/Grid.vala"
			_g_object_unref0 (component);
#line 401 "Grid.c"
		}
#line 100 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (_component_it);
#line 405 "Grid.c"
	}
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 422 "Grid.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 120 "../src/Widgets/calendar/Grid.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 430 "Grid.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/Widgets/calendar/Grid.vala"
	return self ? g_object_ref (self) : NULL;
#line 438 "Grid.c"
}

static void
date_time_widgets_grid_on_day_focus_in (DateTimeWidgetsGrid* self,
                                        DateTimeWidgetsGridDay* day)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DateTimeWidgetsGridDay* _tmp4_;
	GDateTime* selected_date = NULL;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	DateTimeWidgetsGridDay* _tmp9_;
#line 114 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (day != NULL);
#line 115 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = date_time_widgets_grid_day_get_date (day);
#line 115 "../src/Widgets/calendar/Grid.vala"
	_tmp1_ = _tmp0_;
#line 115 "../src/Widgets/calendar/Grid.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 115 "../src/Widgets/calendar/Grid.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/Widgets/calendar/Grid.vala"
	g_debug ("Grid.vala:115: on_day_focus_in %s", _tmp3_);
#line 115 "../src/Widgets/calendar/Grid.vala"
	_g_free0 (_tmp3_);
#line 116 "../src/Widgets/calendar/Grid.vala"
	_tmp4_ = self->priv->selected_gridday;
#line 116 "../src/Widgets/calendar/Grid.vala"
	if (_tmp4_ != NULL) {
#line 475 "Grid.c"
		DateTimeWidgetsGridDay* _tmp5_;
#line 117 "../src/Widgets/calendar/Grid.vala"
		_tmp5_ = self->priv->selected_gridday;
#line 117 "../src/Widgets/calendar/Grid.vala"
		date_time_widgets_grid_day_set_selected (_tmp5_, FALSE);
#line 481 "Grid.c"
	}
#line 120 "../src/Widgets/calendar/Grid.vala"
	_tmp6_ = date_time_widgets_grid_day_get_date (day);
#line 120 "../src/Widgets/calendar/Grid.vala"
	_tmp7_ = _tmp6_;
#line 120 "../src/Widgets/calendar/Grid.vala"
	_tmp8_ = _g_date_time_ref0 (_tmp7_);
#line 120 "../src/Widgets/calendar/Grid.vala"
	selected_date = _tmp8_;
#line 121 "../src/Widgets/calendar/Grid.vala"
	_tmp9_ = _g_object_ref0 (day);
#line 121 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (self->priv->selected_gridday);
#line 121 "../src/Widgets/calendar/Grid.vala"
	self->priv->selected_gridday = _tmp9_;
#line 122 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_day_set_selected (day, TRUE);
#line 123 "../src/Widgets/calendar/Grid.vala"
	gtk_widget_set_state_flags ((GtkWidget*) day, GTK_STATE_FLAG_FOCUSED, FALSE);
#line 124 "../src/Widgets/calendar/Grid.vala"
	g_signal_emit (self, date_time_widgets_grid_signals[DATE_TIME_WIDGETS_GRID_SELECTION_CHANGED_SIGNAL], 0, selected_date);
#line 114 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (selected_date);
#line 505 "Grid.c"
}

void
date_time_widgets_grid_set_focus_to_today (DateTimeWidgetsGrid* self)
{
	UtilDateRange* _tmp0_;
	GeeList* dates = NULL;
	UtilDateRange* _tmp1_;
	GeeList* _tmp2_;
#line 128 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = self->priv->_grid_range;
#line 129 "../src/Widgets/calendar/Grid.vala"
	if (_tmp0_ == NULL) {
#line 130 "../src/Widgets/calendar/Grid.vala"
		return;
#line 523 "Grid.c"
	}
#line 132 "../src/Widgets/calendar/Grid.vala"
	_tmp1_ = self->priv->_grid_range;
#line 132 "../src/Widgets/calendar/Grid.vala"
	_tmp2_ = util_date_range_to_list (_tmp1_);
#line 132 "../src/Widgets/calendar/Grid.vala"
	dates = _tmp2_;
#line 531 "Grid.c"
	{
		gint i = 0;
#line 133 "../src/Widgets/calendar/Grid.vala"
		i = 0;
#line 536 "Grid.c"
		{
			gboolean _tmp3_ = FALSE;
#line 133 "../src/Widgets/calendar/Grid.vala"
			_tmp3_ = TRUE;
#line 133 "../src/Widgets/calendar/Grid.vala"
			while (TRUE) {
#line 543 "Grid.c"
				GeeList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				GDateTime* date = NULL;
				GeeList* _tmp8_;
				gpointer _tmp9_;
				DateTimeWidgetsGridDay* day = NULL;
				GeeHashMap* _tmp10_;
				GDateTime* _tmp11_;
				gpointer _tmp12_;
				gboolean _tmp13_ = FALSE;
				DateTimeWidgetsGridDay* _tmp14_;
#line 133 "../src/Widgets/calendar/Grid.vala"
				if (!_tmp3_) {
#line 558 "Grid.c"
					gint _tmp4_;
#line 133 "../src/Widgets/calendar/Grid.vala"
					_tmp4_ = i;
#line 133 "../src/Widgets/calendar/Grid.vala"
					i = _tmp4_ + 1;
#line 564 "Grid.c"
				}
#line 133 "../src/Widgets/calendar/Grid.vala"
				_tmp3_ = FALSE;
#line 133 "../src/Widgets/calendar/Grid.vala"
				_tmp5_ = dates;
#line 133 "../src/Widgets/calendar/Grid.vala"
				_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 133 "../src/Widgets/calendar/Grid.vala"
				_tmp7_ = _tmp6_;
#line 133 "../src/Widgets/calendar/Grid.vala"
				if (!(i < _tmp7_)) {
#line 133 "../src/Widgets/calendar/Grid.vala"
					break;
#line 578 "Grid.c"
				}
#line 134 "../src/Widgets/calendar/Grid.vala"
				_tmp8_ = dates;
#line 134 "../src/Widgets/calendar/Grid.vala"
				_tmp9_ = gee_list_get (_tmp8_, i);
#line 134 "../src/Widgets/calendar/Grid.vala"
				date = (GDateTime*) _tmp9_;
#line 135 "../src/Widgets/calendar/Grid.vala"
				_tmp10_ = self->priv->data;
#line 135 "../src/Widgets/calendar/Grid.vala"
				_tmp11_ = date;
#line 135 "../src/Widgets/calendar/Grid.vala"
				_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) date_time_widgets_grid_day_hash (self, _tmp11_)));
#line 135 "../src/Widgets/calendar/Grid.vala"
				day = (DateTimeWidgetsGridDay*) _tmp12_;
#line 136 "../src/Widgets/calendar/Grid.vala"
				_tmp14_ = day;
#line 136 "../src/Widgets/calendar/Grid.vala"
				if (_tmp14_ != NULL) {
#line 598 "Grid.c"
					DateTimeWidgetsGridDay* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
#line 136 "../src/Widgets/calendar/Grid.vala"
					_tmp15_ = day;
#line 136 "../src/Widgets/calendar/Grid.vala"
					_tmp16_ = gtk_widget_get_name ((GtkWidget*) _tmp15_);
#line 136 "../src/Widgets/calendar/Grid.vala"
					_tmp17_ = _tmp16_;
#line 136 "../src/Widgets/calendar/Grid.vala"
					_tmp13_ = g_strcmp0 (_tmp17_, "today") == 0;
#line 610 "Grid.c"
				} else {
#line 136 "../src/Widgets/calendar/Grid.vala"
					_tmp13_ = FALSE;
#line 614 "Grid.c"
				}
#line 136 "../src/Widgets/calendar/Grid.vala"
				if (_tmp13_) {
#line 618 "Grid.c"
					DateTimeWidgetsGridDay* _tmp18_;
#line 137 "../src/Widgets/calendar/Grid.vala"
					_tmp18_ = day;
#line 137 "../src/Widgets/calendar/Grid.vala"
					date_time_widgets_grid_day_grab_focus_force (_tmp18_);
#line 138 "../src/Widgets/calendar/Grid.vala"
					_g_object_unref0 (day);
#line 138 "../src/Widgets/calendar/Grid.vala"
					_g_date_time_unref0 (date);
#line 138 "../src/Widgets/calendar/Grid.vala"
					_g_object_unref0 (dates);
#line 138 "../src/Widgets/calendar/Grid.vala"
					return;
#line 632 "Grid.c"
				}
#line 133 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (day);
#line 133 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (date);
#line 638 "Grid.c"
			}
		}
	}
#line 128 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (dates);
#line 644 "Grid.c"
}

/**
         * Sets the given range to be displayed in the grid. Note that the number of days
         * must remain the same.
         */
static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 177 "../src/Widgets/calendar/Grid.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 177 "../src/Widgets/calendar/Grid.vala"
	return _data8_;
#line 658 "Grid.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 177 "../src/Widgets/calendar/Grid.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 668 "Grid.c"
		DateTimeWidgetsGrid* self;
#line 177 "../src/Widgets/calendar/Grid.vala"
		self = _data8_->self;
#line 177 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (_data8_->day);
#line 177 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (self);
#line 177 "../src/Widgets/calendar/Grid.vala"
		g_slice_free (Block8Data, _data8_);
#line 678 "Grid.c"
	}
}

static void
_____lambda23_ (DateTimeWidgetsGrid* self,
                GDateTime* date)
{
#line 189 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (date != NULL);
#line 189 "../src/Widgets/calendar/Grid.vala"
	g_signal_emit (self, date_time_widgets_grid_signals[DATE_TIME_WIDGETS_GRID_ON_EVENT_ADD_SIGNAL], 0, date);
#line 690 "Grid.c"
}

static void
______lambda23__date_time_widgets_grid_day_on_event_add (DateTimeWidgetsGridDay* _sender,
                                                         GDateTime* date,
                                                         gpointer self)
{
#line 189 "../src/Widgets/calendar/Grid.vala"
	_____lambda23_ ((DateTimeWidgetsGrid*) self, date);
#line 700 "Grid.c"
}

static gboolean
_____lambda24_ (Block8Data* _data8_,
                GdkEventFocus* event)
{
	DateTimeWidgetsGrid* self;
	DateTimeWidgetsGridDay* _tmp0_;
	gboolean result;
#line 190 "../src/Widgets/calendar/Grid.vala"
	self = _data8_->self;
#line 190 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 191 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = _data8_->day;
#line 191 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_on_day_focus_in (self, _tmp0_);
#line 193 "../src/Widgets/calendar/Grid.vala"
	result = FALSE;
#line 193 "../src/Widgets/calendar/Grid.vala"
	return result;
#line 722 "Grid.c"
}

static gboolean
______lambda24__gtk_widget_focus_in_event (GtkWidget* _sender,
                                           GdkEventFocus* event,
                                           gpointer self)
{
	gboolean result;
	result = _____lambda24_ (self, event);
#line 190 "../src/Widgets/calendar/Grid.vala"
	return result;
#line 734 "Grid.c"
}

void
date_time_widgets_grid_set_range (DateTimeWidgetsGrid* self,
                                  UtilDateRange* new_range,
                                  GDateTime* month_start)
{
	GDateTime* today = NULL;
	GDateTime* _tmp0_;
	GeeList* old_dates = NULL;
	UtilDateRange* _tmp1_;
	GeeList* new_dates = NULL;
	GeeList* _tmp5_;
	GeeHashMap* data_new = NULL;
	GeeHashMap* _tmp6_;
	GeeList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GDateTime* date = NULL;
	GDateTime* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	DateTimeWidgetsCalendarModel* _tmp13_;
	GDateWeekday _tmp14_;
	GDateWeekday _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	GtkLabel** _tmp18_;
	gint _tmp18__length1;
	gint i = 0;
	gint col = 0;
	gint row = 0;
	GeeHashMap* _tmp69_;
	GeeHashMap* _tmp70_;
	GeeHashMap* _tmp71_;
#line 147 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (new_range != NULL);
#line 147 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (month_start != NULL);
#line 148 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 148 "../src/Widgets/calendar/Grid.vala"
	today = _tmp0_;
#line 152 "../src/Widgets/calendar/Grid.vala"
	_tmp1_ = self->priv->_grid_range;
#line 152 "../src/Widgets/calendar/Grid.vala"
	if (_tmp1_ == NULL) {
#line 784 "Grid.c"
		GeeArrayList* _tmp2_;
#line 153 "../src/Widgets/calendar/Grid.vala"
		_tmp2_ = gee_array_list_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, NULL, NULL, NULL);
#line 153 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (old_dates);
#line 153 "../src/Widgets/calendar/Grid.vala"
		old_dates = (GeeList*) _tmp2_;
#line 792 "Grid.c"
	} else {
		UtilDateRange* _tmp3_;
		GeeList* _tmp4_;
#line 155 "../src/Widgets/calendar/Grid.vala"
		_tmp3_ = self->priv->_grid_range;
#line 155 "../src/Widgets/calendar/Grid.vala"
		_tmp4_ = util_date_range_to_list (_tmp3_);
#line 155 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (old_dates);
#line 155 "../src/Widgets/calendar/Grid.vala"
		old_dates = _tmp4_;
#line 804 "Grid.c"
	}
#line 158 "../src/Widgets/calendar/Grid.vala"
	_tmp5_ = util_date_range_to_list (new_range);
#line 158 "../src/Widgets/calendar/Grid.vala"
	new_dates = _tmp5_;
#line 160 "../src/Widgets/calendar/Grid.vala"
	_tmp6_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, DATE_TIME_WIDGETS_TYPE_GRID_DAY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 160 "../src/Widgets/calendar/Grid.vala"
	data_new = _tmp6_;
#line 163 "../src/Widgets/calendar/Grid.vala"
	_tmp7_ = new_dates;
#line 163 "../src/Widgets/calendar/Grid.vala"
	_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 163 "../src/Widgets/calendar/Grid.vala"
	_tmp9_ = _tmp8_;
#line 163 "../src/Widgets/calendar/Grid.vala"
	_vala_assert ((_tmp9_ % 7) == 0, "new_dates.size % 7 == 0");
#line 167 "../src/Widgets/calendar/Grid.vala"
	_tmp10_ = today;
#line 167 "../src/Widgets/calendar/Grid.vala"
	_tmp11_ = util_strip_time (_tmp10_);
#line 167 "../src/Widgets/calendar/Grid.vala"
	date = _tmp11_;
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp12_ = date;
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp13_ = date_time_widgets_grid_events_model;
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp14_ = date_time_widgets_calendar_model_get_week_starts_on (_tmp13_);
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp15_ = _tmp14_;
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp16_ = date;
#line 168 "../src/Widgets/calendar/Grid.vala"
	_tmp17_ = g_date_time_add_days (_tmp12_, (gint) (_tmp15_ - g_date_time_get_day_of_week (_tmp16_)));
#line 168 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (date);
#line 168 "../src/Widgets/calendar/Grid.vala"
	date = _tmp17_;
#line 169 "../src/Widgets/calendar/Grid.vala"
	_tmp18_ = self->priv->header_labels;
#line 169 "../src/Widgets/calendar/Grid.vala"
	_tmp18__length1 = self->priv->header_labels_length1;
#line 848 "Grid.c"
	{
		GtkLabel** label_collection = NULL;
		gint label_collection_length1 = 0;
		gint _label_collection_size_ = 0;
		gint label_it = 0;
#line 169 "../src/Widgets/calendar/Grid.vala"
		label_collection = _tmp18_;
#line 169 "../src/Widgets/calendar/Grid.vala"
		label_collection_length1 = _tmp18__length1;
#line 169 "../src/Widgets/calendar/Grid.vala"
		for (label_it = 0; label_it < label_collection_length1; label_it = label_it + 1) {
#line 860 "Grid.c"
			GtkLabel* _tmp19_;
			GtkLabel* label = NULL;
#line 169 "../src/Widgets/calendar/Grid.vala"
			_tmp19_ = _g_object_ref0 (label_collection[label_it]);
#line 169 "../src/Widgets/calendar/Grid.vala"
			label = _tmp19_;
#line 867 "Grid.c"
			{
				GtkLabel* _tmp20_;
				GDateTime* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				GDateTime* _tmp24_;
				GDateTime* _tmp25_;
#line 170 "../src/Widgets/calendar/Grid.vala"
				_tmp20_ = label;
#line 170 "../src/Widgets/calendar/Grid.vala"
				_tmp21_ = date;
#line 170 "../src/Widgets/calendar/Grid.vala"
				_tmp22_ = g_date_time_format (_tmp21_, "%a");
#line 170 "../src/Widgets/calendar/Grid.vala"
				_tmp23_ = _tmp22_;
#line 170 "../src/Widgets/calendar/Grid.vala"
				gtk_label_set_label (_tmp20_, _tmp23_);
#line 170 "../src/Widgets/calendar/Grid.vala"
				_g_free0 (_tmp23_);
#line 171 "../src/Widgets/calendar/Grid.vala"
				_tmp24_ = date;
#line 171 "../src/Widgets/calendar/Grid.vala"
				_tmp25_ = g_date_time_add_days (_tmp24_, 1);
#line 171 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (date);
#line 171 "../src/Widgets/calendar/Grid.vala"
				date = _tmp25_;
#line 169 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (label);
#line 897 "Grid.c"
			}
		}
	}
#line 174 "../src/Widgets/calendar/Grid.vala"
	i = 0;
#line 175 "../src/Widgets/calendar/Grid.vala"
	col = 0;
#line 175 "../src/Widgets/calendar/Grid.vala"
	row = 1;
#line 907 "Grid.c"
	{
		gboolean _tmp26_ = FALSE;
#line 177 "../src/Widgets/calendar/Grid.vala"
		i = 0;
#line 177 "../src/Widgets/calendar/Grid.vala"
		_tmp26_ = TRUE;
#line 177 "../src/Widgets/calendar/Grid.vala"
		while (TRUE) {
#line 916 "Grid.c"
			Block8Data* _data8_;
			GeeList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			GDateTime* new_date = NULL;
			GeeList* _tmp31_;
			gpointer _tmp32_;
			GeeList* _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			gint _tmp55_ = 0;
			GeeHashMap* _tmp56_;
			GDateTime* _tmp57_;
			DateTimeWidgetsGridDay* _tmp58_;
#line 177 "../src/Widgets/calendar/Grid.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 177 "../src/Widgets/calendar/Grid.vala"
			_data8_->_ref_count_ = 1;
#line 177 "../src/Widgets/calendar/Grid.vala"
			_data8_->self = g_object_ref (self);
#line 177 "../src/Widgets/calendar/Grid.vala"
			if (!_tmp26_) {
#line 939 "Grid.c"
				gint _tmp27_;
#line 177 "../src/Widgets/calendar/Grid.vala"
				_tmp27_ = i;
#line 177 "../src/Widgets/calendar/Grid.vala"
				i = _tmp27_ + 1;
#line 945 "Grid.c"
			}
#line 177 "../src/Widgets/calendar/Grid.vala"
			_tmp26_ = FALSE;
#line 177 "../src/Widgets/calendar/Grid.vala"
			_tmp28_ = new_dates;
#line 177 "../src/Widgets/calendar/Grid.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 177 "../src/Widgets/calendar/Grid.vala"
			_tmp30_ = _tmp29_;
#line 177 "../src/Widgets/calendar/Grid.vala"
			if (!(i < _tmp30_)) {
#line 177 "../src/Widgets/calendar/Grid.vala"
				block8_data_unref (_data8_);
#line 177 "../src/Widgets/calendar/Grid.vala"
				_data8_ = NULL;
#line 177 "../src/Widgets/calendar/Grid.vala"
				break;
#line 963 "Grid.c"
			}
#line 178 "../src/Widgets/calendar/Grid.vala"
			_tmp31_ = new_dates;
#line 178 "../src/Widgets/calendar/Grid.vala"
			_tmp32_ = gee_list_get (_tmp31_, i);
#line 178 "../src/Widgets/calendar/Grid.vala"
			new_date = (GDateTime*) _tmp32_;
#line 181 "../src/Widgets/calendar/Grid.vala"
			_tmp33_ = old_dates;
#line 181 "../src/Widgets/calendar/Grid.vala"
			_tmp34_ = gee_collection_get_size ((GeeCollection*) _tmp33_);
#line 181 "../src/Widgets/calendar/Grid.vala"
			_tmp35_ = _tmp34_;
#line 181 "../src/Widgets/calendar/Grid.vala"
			if (i < _tmp35_) {
#line 979 "Grid.c"
				GDateTime* old_date = NULL;
				GeeList* _tmp36_;
				gpointer _tmp37_;
				GeeHashMap* _tmp38_;
				GDateTime* _tmp39_;
				gpointer _tmp40_;
				DateTimeWidgetsGridDay* _tmp41_;
				GDateTime* _tmp42_;
				GDateTime* _tmp43_;
				DateTimeWidgetsGridDay* _tmp44_;
#line 184 "../src/Widgets/calendar/Grid.vala"
				_tmp36_ = old_dates;
#line 184 "../src/Widgets/calendar/Grid.vala"
				_tmp37_ = gee_list_get (_tmp36_, i);
#line 184 "../src/Widgets/calendar/Grid.vala"
				old_date = (GDateTime*) _tmp37_;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp38_ = self->priv->data;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp39_ = old_date;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp38_, (gpointer) ((guintptr) date_time_widgets_grid_day_hash (self, _tmp39_)));
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp41_ = (DateTimeWidgetsGridDay*) _tmp40_;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp42_ = new_date;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp43_ = today;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_tmp44_ = date_time_widgets_grid_update_day (self, _tmp41_, _tmp42_, _tmp43_, month_start);
#line 185 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_data8_->day);
#line 185 "../src/Widgets/calendar/Grid.vala"
				_data8_->day = _tmp44_;
#line 185 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp41_);
#line 181 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (old_date);
#line 1018 "Grid.c"
			} else {
				GDateTime* _tmp45_;
				DateTimeWidgetsGridDay* _tmp46_;
				DateTimeWidgetsGridDay* _tmp47_;
				GDateTime* _tmp48_;
				GDateTime* _tmp49_;
				DateTimeWidgetsGridDay* _tmp50_;
				DateTimeWidgetsGridDay* _tmp51_;
				DateTimeWidgetsGridDay* _tmp52_;
				DateTimeWidgetsGridDay* _tmp53_;
				DateTimeWidgetsGridDay* _tmp54_;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp45_ = new_date;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp46_ = date_time_widgets_grid_day_new (_tmp45_);
#line 188 "../src/Widgets/calendar/Grid.vala"
				g_object_ref_sink (_tmp46_);
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp47_ = _tmp46_;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp48_ = new_date;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp49_ = today;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_tmp50_ = date_time_widgets_grid_update_day (self, _tmp47_, _tmp48_, _tmp49_, month_start);
#line 188 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_data8_->day);
#line 188 "../src/Widgets/calendar/Grid.vala"
				_data8_->day = _tmp50_;
#line 188 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp47_);
#line 189 "../src/Widgets/calendar/Grid.vala"
				_tmp51_ = _data8_->day;
#line 189 "../src/Widgets/calendar/Grid.vala"
				g_signal_connect_object (_tmp51_, "on-event-add", (GCallback) ______lambda23__date_time_widgets_grid_day_on_event_add, self, 0);
#line 190 "../src/Widgets/calendar/Grid.vala"
				_tmp52_ = _data8_->day;
#line 190 "../src/Widgets/calendar/Grid.vala"
				g_signal_connect_data ((GtkWidget*) _tmp52_, "focus-in-event", (GCallback) ______lambda24__gtk_widget_focus_in_event, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 196 "../src/Widgets/calendar/Grid.vala"
				_tmp53_ = _data8_->day;
#line 196 "../src/Widgets/calendar/Grid.vala"
				gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp53_, col + 2, row, 1, 1);
#line 197 "../src/Widgets/calendar/Grid.vala"
				_tmp54_ = _data8_->day;
#line 197 "../src/Widgets/calendar/Grid.vala"
				gtk_widget_show_all ((GtkWidget*) _tmp54_);
#line 1066 "Grid.c"
			}
#line 200 "../src/Widgets/calendar/Grid.vala"
			col = (col + 1) % 7;
#line 201 "../src/Widgets/calendar/Grid.vala"
			if (col == 0) {
#line 201 "../src/Widgets/calendar/Grid.vala"
				_tmp55_ = row + 1;
#line 1074 "Grid.c"
			} else {
#line 201 "../src/Widgets/calendar/Grid.vala"
				_tmp55_ = row;
#line 1078 "Grid.c"
			}
#line 201 "../src/Widgets/calendar/Grid.vala"
			row = _tmp55_;
#line 202 "../src/Widgets/calendar/Grid.vala"
			_tmp56_ = data_new;
#line 202 "../src/Widgets/calendar/Grid.vala"
			_tmp57_ = new_date;
#line 202 "../src/Widgets/calendar/Grid.vala"
			_tmp58_ = _data8_->day;
#line 202 "../src/Widgets/calendar/Grid.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp56_, (gpointer) ((guintptr) date_time_widgets_grid_day_hash (self, _tmp57_)), _tmp58_);
#line 177 "../src/Widgets/calendar/Grid.vala"
			_g_date_time_unref0 (new_date);
#line 177 "../src/Widgets/calendar/Grid.vala"
			block8_data_unref (_data8_);
#line 177 "../src/Widgets/calendar/Grid.vala"
			_data8_ = NULL;
#line 1096 "Grid.c"
		}
	}
#line 206 "../src/Widgets/calendar/Grid.vala"
	while (TRUE) {
#line 1101 "Grid.c"
		GeeList* _tmp59_;
		gint _tmp60_;
		gint _tmp61_;
		GDateTime* old_date = NULL;
		GeeList* _tmp62_;
		gpointer _tmp63_;
		DateTimeWidgetsGridDay* old_day = NULL;
		GeeHashMap* _tmp64_;
		GDateTime* _tmp65_;
		gpointer _tmp66_;
		DateTimeWidgetsGridDay* _tmp67_;
		gint _tmp68_;
#line 206 "../src/Widgets/calendar/Grid.vala"
		_tmp59_ = old_dates;
#line 206 "../src/Widgets/calendar/Grid.vala"
		_tmp60_ = gee_collection_get_size ((GeeCollection*) _tmp59_);
#line 206 "../src/Widgets/calendar/Grid.vala"
		_tmp61_ = _tmp60_;
#line 206 "../src/Widgets/calendar/Grid.vala"
		if (!(i < _tmp61_)) {
#line 206 "../src/Widgets/calendar/Grid.vala"
			break;
#line 1124 "Grid.c"
		}
#line 208 "../src/Widgets/calendar/Grid.vala"
		_tmp62_ = old_dates;
#line 208 "../src/Widgets/calendar/Grid.vala"
		_tmp63_ = gee_list_get (_tmp62_, i);
#line 208 "../src/Widgets/calendar/Grid.vala"
		old_date = (GDateTime*) _tmp63_;
#line 209 "../src/Widgets/calendar/Grid.vala"
		_tmp64_ = self->priv->data;
#line 209 "../src/Widgets/calendar/Grid.vala"
		_tmp65_ = old_date;
#line 209 "../src/Widgets/calendar/Grid.vala"
		_tmp66_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((guintptr) date_time_widgets_grid_day_hash (self, _tmp65_)));
#line 209 "../src/Widgets/calendar/Grid.vala"
		old_day = (DateTimeWidgetsGridDay*) _tmp66_;
#line 211 "../src/Widgets/calendar/Grid.vala"
		_tmp67_ = old_day;
#line 211 "../src/Widgets/calendar/Grid.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp67_);
#line 212 "../src/Widgets/calendar/Grid.vala"
		_tmp68_ = i;
#line 212 "../src/Widgets/calendar/Grid.vala"
		i = _tmp68_ + 1;
#line 206 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (old_day);
#line 206 "../src/Widgets/calendar/Grid.vala"
		_g_date_time_unref0 (old_date);
#line 1152 "Grid.c"
	}
#line 215 "../src/Widgets/calendar/Grid.vala"
	_tmp69_ = self->priv->data;
#line 215 "../src/Widgets/calendar/Grid.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp69_);
#line 216 "../src/Widgets/calendar/Grid.vala"
	_tmp70_ = self->priv->data;
#line 216 "../src/Widgets/calendar/Grid.vala"
	_tmp71_ = data_new;
#line 216 "../src/Widgets/calendar/Grid.vala"
	gee_map_set_all ((GeeMap*) _tmp70_, (GeeMap*) _tmp71_);
#line 218 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_set_grid_range (self, new_range);
#line 147 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (date);
#line 147 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (data_new);
#line 147 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (new_dates);
#line 147 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (old_dates);
#line 147 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (today);
#line 1176 "Grid.c"
}

/**
         * Updates the given GridDay so that it shows the given date. Changes to its style etc.
         */
static DateTimeWidgetsGridDay*
date_time_widgets_grid_update_day (DateTimeWidgetsGrid* self,
                                   DateTimeWidgetsGridDay* day,
                                   GDateTime* new_date,
                                   GDateTime* today,
                                   GDateTime* month_start)
{
	DateTimeWidgetsGridDay* _tmp0_;
	DateTimeWidgetsGridDay* result;
#line 224 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 224 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (day != NULL, NULL);
#line 224 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (new_date != NULL, NULL);
#line 224 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (today != NULL, NULL);
#line 224 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (month_start != NULL, NULL);
#line 225 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_update_today_style (self, day, new_date, today);
#line 226 "../src/Widgets/calendar/Grid.vala"
	if (g_date_time_get_month (new_date) == g_date_time_get_month (month_start)) {
#line 227 "../src/Widgets/calendar/Grid.vala"
		date_time_widgets_grid_day_sensitive_container (day, TRUE);
#line 1207 "Grid.c"
	} else {
#line 229 "../src/Widgets/calendar/Grid.vala"
		date_time_widgets_grid_day_sensitive_container (day, FALSE);
#line 1211 "Grid.c"
	}
#line 232 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_day_set_date (day, new_date);
#line 234 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = _g_object_ref0 (day);
#line 234 "../src/Widgets/calendar/Grid.vala"
	result = _tmp0_;
#line 234 "../src/Widgets/calendar/Grid.vala"
	return result;
#line 1221 "Grid.c"
}

void
date_time_widgets_grid_update_weeks (DateTimeWidgetsGrid* self,
                                     GDateTime* date,
                                     gint nr_of_weeks)
{
	GtkRevealer** _tmp0_;
	gint _tmp0__length1;
	GDateTime* next = NULL;
	GDateTime* _tmp3_;
	gint days_to_add = 0;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GtkRevealer** _tmp7_;
#line 237 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (date != NULL);
#line 238 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = self->priv->week_labels;
#line 238 "../src/Widgets/calendar/Grid.vala"
	_tmp0__length1 = self->priv->week_labels_length1;
#line 238 "../src/Widgets/calendar/Grid.vala"
	if (_tmp0_ != NULL) {
#line 1248 "Grid.c"
		GtkRevealer** _tmp1_;
		gint _tmp1__length1;
#line 239 "../src/Widgets/calendar/Grid.vala"
		_tmp1_ = self->priv->week_labels;
#line 239 "../src/Widgets/calendar/Grid.vala"
		_tmp1__length1 = self->priv->week_labels_length1;
#line 1255 "Grid.c"
		{
			GtkRevealer** widget_collection = NULL;
			gint widget_collection_length1 = 0;
			gint _widget_collection_size_ = 0;
			gint widget_it = 0;
#line 239 "../src/Widgets/calendar/Grid.vala"
			widget_collection = _tmp1_;
#line 239 "../src/Widgets/calendar/Grid.vala"
			widget_collection_length1 = _tmp1__length1;
#line 239 "../src/Widgets/calendar/Grid.vala"
			for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1267 "Grid.c"
				GtkWidget* widget = NULL;
#line 239 "../src/Widgets/calendar/Grid.vala"
				widget = (GtkWidget*) widget_collection[widget_it];
#line 1271 "Grid.c"
				{
					GtkWidget* _tmp2_;
#line 240 "../src/Widgets/calendar/Grid.vala"
					_tmp2_ = widget;
#line 240 "../src/Widgets/calendar/Grid.vala"
					gtk_widget_destroy (_tmp2_);
#line 1278 "Grid.c"
				}
			}
		}
	}
#line 244 "../src/Widgets/calendar/Grid.vala"
	_tmp3_ = _g_date_time_ref0 (date);
#line 244 "../src/Widgets/calendar/Grid.vala"
	next = _tmp3_;
#line 246 "../src/Widgets/calendar/Grid.vala"
	_tmp4_ = next;
#line 246 "../src/Widgets/calendar/Grid.vala"
	days_to_add = (8 - g_date_time_get_day_of_week (_tmp4_)) % 7;
#line 247 "../src/Widgets/calendar/Grid.vala"
	_tmp5_ = next;
#line 247 "../src/Widgets/calendar/Grid.vala"
	_tmp6_ = g_date_time_add_days (_tmp5_, days_to_add);
#line 247 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (next);
#line 247 "../src/Widgets/calendar/Grid.vala"
	next = _tmp6_;
#line 249 "../src/Widgets/calendar/Grid.vala"
	_tmp7_ = g_new0 (GtkRevealer*, nr_of_weeks + 1);
#line 249 "../src/Widgets/calendar/Grid.vala"
	self->priv->week_labels = (_vala_array_free (self->priv->week_labels, self->priv->week_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 249 "../src/Widgets/calendar/Grid.vala"
	self->priv->week_labels = _tmp7_;
#line 249 "../src/Widgets/calendar/Grid.vala"
	self->priv->week_labels_length1 = nr_of_weeks;
#line 249 "../src/Widgets/calendar/Grid.vala"
	self->priv->_week_labels_size_ = self->priv->week_labels_length1;
#line 1309 "Grid.c"
	{
		gint c = 0;
#line 250 "../src/Widgets/calendar/Grid.vala"
		c = 0;
#line 1314 "Grid.c"
		{
			gboolean _tmp8_ = FALSE;
#line 250 "../src/Widgets/calendar/Grid.vala"
			_tmp8_ = TRUE;
#line 250 "../src/Widgets/calendar/Grid.vala"
			while (TRUE) {
#line 1321 "Grid.c"
				GtkLabel* week_label = NULL;
				GDateTime* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GtkLabel* _tmp13_ = NULL;
				GtkLabel* _tmp14_;
				GtkLabel* _tmp15_;
				GtkStyleContext* _tmp16_;
				GtkRevealer** _tmp17_;
				gint _tmp17__length1;
				GtkRevealer* _tmp18_ = NULL;
				GtkRevealer** _tmp19_;
				gint _tmp19__length1;
				GtkRevealer* _tmp20_;
				GtkLabel* _tmp21_;
				GtkRevealer** _tmp22_;
				gint _tmp22__length1;
				GtkRevealer* _tmp23_;
				GSettings* _tmp24_;
				GtkRevealer** _tmp25_;
				gint _tmp25__length1;
				GtkRevealer* _tmp26_;
				GtkRevealer** _tmp27_;
				gint _tmp27__length1;
				GtkRevealer* _tmp28_;
				GDateTime* _tmp29_;
				GDateTime* _tmp30_;
#line 250 "../src/Widgets/calendar/Grid.vala"
				if (!_tmp8_) {
#line 1351 "Grid.c"
					gint _tmp9_;
#line 250 "../src/Widgets/calendar/Grid.vala"
					_tmp9_ = c;
#line 250 "../src/Widgets/calendar/Grid.vala"
					c = _tmp9_ + 1;
#line 1357 "Grid.c"
				}
#line 250 "../src/Widgets/calendar/Grid.vala"
				_tmp8_ = FALSE;
#line 250 "../src/Widgets/calendar/Grid.vala"
				if (!(c < nr_of_weeks)) {
#line 250 "../src/Widgets/calendar/Grid.vala"
					break;
#line 1365 "Grid.c"
				}
#line 251 "../src/Widgets/calendar/Grid.vala"
				_tmp10_ = next;
#line 251 "../src/Widgets/calendar/Grid.vala"
				_tmp11_ = g_strdup_printf ("%i", g_date_time_get_week_of_year (_tmp10_));
#line 251 "../src/Widgets/calendar/Grid.vala"
				_tmp12_ = _tmp11_;
#line 251 "../src/Widgets/calendar/Grid.vala"
				_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
#line 251 "../src/Widgets/calendar/Grid.vala"
				gtk_widget_set_margin_bottom ((GtkWidget*) _tmp13_, 6);
#line 251 "../src/Widgets/calendar/Grid.vala"
				gtk_label_set_width_chars (_tmp13_, 2);
#line 251 "../src/Widgets/calendar/Grid.vala"
				g_object_ref_sink (_tmp13_);
#line 251 "../src/Widgets/calendar/Grid.vala"
				_tmp14_ = _tmp13_;
#line 251 "../src/Widgets/calendar/Grid.vala"
				_g_free0 (_tmp12_);
#line 251 "../src/Widgets/calendar/Grid.vala"
				week_label = _tmp14_;
#line 255 "../src/Widgets/calendar/Grid.vala"
				_tmp15_ = week_label;
#line 255 "../src/Widgets/calendar/Grid.vala"
				_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 255 "../src/Widgets/calendar/Grid.vala"
				gtk_style_context_add_class (_tmp16_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 257 "../src/Widgets/calendar/Grid.vala"
				_tmp17_ = self->priv->week_labels;
#line 257 "../src/Widgets/calendar/Grid.vala"
				_tmp17__length1 = self->priv->week_labels_length1;
#line 257 "../src/Widgets/calendar/Grid.vala"
				_tmp18_ = (GtkRevealer*) gtk_revealer_new ();
#line 257 "../src/Widgets/calendar/Grid.vala"
				gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 257 "../src/Widgets/calendar/Grid.vala"
				g_object_ref_sink (_tmp18_);
#line 257 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp17_[c]);
#line 257 "../src/Widgets/calendar/Grid.vala"
				_tmp17_[c] = _tmp18_;
#line 260 "../src/Widgets/calendar/Grid.vala"
				_tmp19_ = self->priv->week_labels;
#line 260 "../src/Widgets/calendar/Grid.vala"
				_tmp19__length1 = self->priv->week_labels_length1;
#line 260 "../src/Widgets/calendar/Grid.vala"
				_tmp20_ = _tmp19_[c];
#line 260 "../src/Widgets/calendar/Grid.vala"
				_tmp21_ = week_label;
#line 260 "../src/Widgets/calendar/Grid.vala"
				gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 261 "../src/Widgets/calendar/Grid.vala"
				_tmp22_ = self->priv->week_labels;
#line 261 "../src/Widgets/calendar/Grid.vala"
				_tmp22__length1 = self->priv->week_labels_length1;
#line 261 "../src/Widgets/calendar/Grid.vala"
				_tmp23_ = _tmp22_[c];
#line 261 "../src/Widgets/calendar/Grid.vala"
				gtk_widget_show_all ((GtkWidget*) _tmp23_);
#line 263 "../src/Widgets/calendar/Grid.vala"
				_tmp24_ = date_time_indicator_settings;
#line 263 "../src/Widgets/calendar/Grid.vala"
				_tmp25_ = self->priv->week_labels;
#line 263 "../src/Widgets/calendar/Grid.vala"
				_tmp25__length1 = self->priv->week_labels_length1;
#line 263 "../src/Widgets/calendar/Grid.vala"
				_tmp26_ = _tmp25_[c];
#line 263 "../src/Widgets/calendar/Grid.vala"
				g_settings_bind (_tmp24_, "show-weeks", (GObject*) _tmp26_, "reveal-child", G_SETTINGS_BIND_DEFAULT);
#line 265 "../src/Widgets/calendar/Grid.vala"
				_tmp27_ = self->priv->week_labels;
#line 265 "../src/Widgets/calendar/Grid.vala"
				_tmp27__length1 = self->priv->week_labels_length1;
#line 265 "../src/Widgets/calendar/Grid.vala"
				_tmp28_ = _tmp27_[c];
#line 265 "../src/Widgets/calendar/Grid.vala"
				gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp28_, 0, c + 1, 1, 1);
#line 267 "../src/Widgets/calendar/Grid.vala"
				_tmp29_ = next;
#line 267 "../src/Widgets/calendar/Grid.vala"
				_tmp30_ = g_date_time_add_weeks (_tmp29_, 1);
#line 267 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (next);
#line 267 "../src/Widgets/calendar/Grid.vala"
				next = _tmp30_;
#line 250 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (week_label);
#line 1453 "Grid.c"
			}
		}
	}
#line 237 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (next);
#line 1459 "Grid.c"
}

void
date_time_widgets_grid_update_today (DateTimeWidgetsGrid* self)
{
	UtilDateRange* _tmp0_;
	GeeList* dates = NULL;
	UtilDateRange* _tmp1_;
	GeeList* _tmp2_;
	GDateTime* today = NULL;
	GDateTime* _tmp3_;
	gint i = 0;
#line 271 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = self->priv->_grid_range;
#line 272 "../src/Widgets/calendar/Grid.vala"
	if (_tmp0_ == NULL) {
#line 272 "../src/Widgets/calendar/Grid.vala"
		return;
#line 1480 "Grid.c"
	}
#line 273 "../src/Widgets/calendar/Grid.vala"
	_tmp1_ = self->priv->_grid_range;
#line 273 "../src/Widgets/calendar/Grid.vala"
	_tmp2_ = util_date_range_to_list (_tmp1_);
#line 273 "../src/Widgets/calendar/Grid.vala"
	dates = _tmp2_;
#line 274 "../src/Widgets/calendar/Grid.vala"
	_tmp3_ = g_date_time_new_now_local ();
#line 274 "../src/Widgets/calendar/Grid.vala"
	today = _tmp3_;
#line 276 "../src/Widgets/calendar/Grid.vala"
	i = 0;
#line 1494 "Grid.c"
	{
		gboolean _tmp4_ = FALSE;
#line 277 "../src/Widgets/calendar/Grid.vala"
		i = 0;
#line 277 "../src/Widgets/calendar/Grid.vala"
		_tmp4_ = TRUE;
#line 277 "../src/Widgets/calendar/Grid.vala"
		while (TRUE) {
#line 1503 "Grid.c"
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GDateTime* date = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			DateTimeWidgetsGridDay* day = NULL;
			GeeHashMap* _tmp11_;
			GDateTime* _tmp12_;
			gpointer _tmp13_;
			DateTimeWidgetsGridDay* _tmp14_;
			DateTimeWidgetsGridDay* _tmp15_;
			GDateTime* _tmp16_;
			GDateTime* _tmp17_;
#line 277 "../src/Widgets/calendar/Grid.vala"
			if (!_tmp4_) {
#line 1520 "Grid.c"
				gint _tmp5_;
#line 277 "../src/Widgets/calendar/Grid.vala"
				_tmp5_ = i;
#line 277 "../src/Widgets/calendar/Grid.vala"
				i = _tmp5_ + 1;
#line 1526 "Grid.c"
			}
#line 277 "../src/Widgets/calendar/Grid.vala"
			_tmp4_ = FALSE;
#line 277 "../src/Widgets/calendar/Grid.vala"
			_tmp6_ = dates;
#line 277 "../src/Widgets/calendar/Grid.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 277 "../src/Widgets/calendar/Grid.vala"
			_tmp8_ = _tmp7_;
#line 277 "../src/Widgets/calendar/Grid.vala"
			if (!(i < _tmp8_)) {
#line 277 "../src/Widgets/calendar/Grid.vala"
				break;
#line 1540 "Grid.c"
			}
#line 278 "../src/Widgets/calendar/Grid.vala"
			_tmp9_ = dates;
#line 278 "../src/Widgets/calendar/Grid.vala"
			_tmp10_ = gee_list_get (_tmp9_, i);
#line 278 "../src/Widgets/calendar/Grid.vala"
			date = (GDateTime*) _tmp10_;
#line 279 "../src/Widgets/calendar/Grid.vala"
			_tmp11_ = self->priv->data;
#line 279 "../src/Widgets/calendar/Grid.vala"
			_tmp12_ = date;
#line 279 "../src/Widgets/calendar/Grid.vala"
			_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (gpointer) ((guintptr) date_time_widgets_grid_day_hash (self, _tmp12_)));
#line 279 "../src/Widgets/calendar/Grid.vala"
			day = (DateTimeWidgetsGridDay*) _tmp13_;
#line 280 "../src/Widgets/calendar/Grid.vala"
			_tmp14_ = day;
#line 280 "../src/Widgets/calendar/Grid.vala"
			if (_tmp14_ == NULL) {
#line 280 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (day);
#line 280 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (date);
#line 280 "../src/Widgets/calendar/Grid.vala"
				_g_date_time_unref0 (today);
#line 280 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (dates);
#line 280 "../src/Widgets/calendar/Grid.vala"
				return;
#line 1570 "Grid.c"
			}
#line 281 "../src/Widgets/calendar/Grid.vala"
			_tmp15_ = day;
#line 281 "../src/Widgets/calendar/Grid.vala"
			_tmp16_ = date;
#line 281 "../src/Widgets/calendar/Grid.vala"
			_tmp17_ = today;
#line 281 "../src/Widgets/calendar/Grid.vala"
			date_time_widgets_grid_update_today_style (self, _tmp15_, _tmp16_, _tmp17_);
#line 277 "../src/Widgets/calendar/Grid.vala"
			_g_object_unref0 (day);
#line 277 "../src/Widgets/calendar/Grid.vala"
			_g_date_time_unref0 (date);
#line 1584 "Grid.c"
		}
	}
#line 271 "../src/Widgets/calendar/Grid.vala"
	_g_date_time_unref0 (today);
#line 271 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (dates);
#line 1591 "Grid.c"
}

static void
date_time_widgets_grid_update_today_style (DateTimeWidgetsGrid* self,
                                           DateTimeWidgetsGridDay* day,
                                           GDateTime* date,
                                           GDateTime* today)
{
	gboolean _tmp0_ = FALSE;
#line 285 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (day != NULL);
#line 285 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (date != NULL);
#line 285 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (today != NULL);
#line 286 "../src/Widgets/calendar/Grid.vala"
	if (g_date_time_get_day_of_year (date) == g_date_time_get_day_of_year (today)) {
#line 286 "../src/Widgets/calendar/Grid.vala"
		_tmp0_ = g_date_time_get_year (date) == g_date_time_get_year (today);
#line 1613 "Grid.c"
	} else {
#line 286 "../src/Widgets/calendar/Grid.vala"
		_tmp0_ = FALSE;
#line 1617 "Grid.c"
	}
#line 286 "../src/Widgets/calendar/Grid.vala"
	if (_tmp0_) {
#line 1621 "Grid.c"
		GtkStyleContext* _tmp1_;
#line 287 "../src/Widgets/calendar/Grid.vala"
		gtk_widget_set_name ((GtkWidget*) day, "today");
#line 288 "../src/Widgets/calendar/Grid.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) day);
#line 288 "../src/Widgets/calendar/Grid.vala"
		gtk_style_context_add_class (_tmp1_, GRANITE_STYLE_CLASS_ACCENT);
#line 289 "../src/Widgets/calendar/Grid.vala"
		gtk_widget_set_receives_default ((GtkWidget*) day, TRUE);
#line 290 "../src/Widgets/calendar/Grid.vala"
		gtk_widget_show_all ((GtkWidget*) day);
#line 1633 "Grid.c"
	} else {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 291 "../src/Widgets/calendar/Grid.vala"
		_tmp2_ = gtk_widget_get_name ((GtkWidget*) day);
#line 291 "../src/Widgets/calendar/Grid.vala"
		_tmp3_ = _tmp2_;
#line 291 "../src/Widgets/calendar/Grid.vala"
		if (g_strcmp0 (_tmp3_, "today") == 0) {
#line 1643 "Grid.c"
			GtkStyleContext* _tmp4_;
#line 292 "../src/Widgets/calendar/Grid.vala"
			gtk_widget_set_name ((GtkWidget*) day, "");
#line 293 "../src/Widgets/calendar/Grid.vala"
			_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) day);
#line 293 "../src/Widgets/calendar/Grid.vala"
			gtk_style_context_remove_class (_tmp4_, GRANITE_STYLE_CLASS_ACCENT);
#line 294 "../src/Widgets/calendar/Grid.vala"
			gtk_widget_set_receives_default ((GtkWidget*) day, FALSE);
#line 295 "../src/Widgets/calendar/Grid.vala"
			gtk_widget_show_all ((GtkWidget*) day);
#line 1655 "Grid.c"
		}
	}
}

static guint
date_time_widgets_grid_day_hash (DateTimeWidgetsGrid* self,
                                 GDateTime* date)
{
	guint result;
#line 299 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 299 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (date != NULL, 0U);
#line 300 "../src/Widgets/calendar/Grid.vala"
	result = (guint) (((g_date_time_get_year (date) * 10000) + (g_date_time_get_month (date) * 100)) + g_date_time_get_day_of_month (date));
#line 300 "../src/Widgets/calendar/Grid.vala"
	return result;
#line 1673 "Grid.c"
}

DateTimeWidgetsGrid*
date_time_widgets_grid_construct (GType object_type)
{
	DateTimeWidgetsGrid * self = NULL;
#line 27 "../src/Widgets/calendar/Grid.vala"
	self = (DateTimeWidgetsGrid*) g_object_new (object_type, NULL);
#line 27 "../src/Widgets/calendar/Grid.vala"
	return self;
#line 1684 "Grid.c"
}

DateTimeWidgetsGrid*
date_time_widgets_grid_new (void)
{
#line 27 "../src/Widgets/calendar/Grid.vala"
	return date_time_widgets_grid_construct (DATE_TIME_WIDGETS_TYPE_GRID);
#line 1692 "Grid.c"
}

UtilDateRange*
date_time_widgets_grid_get_grid_range (DateTimeWidgetsGrid* self)
{
	UtilDateRange* result;
	UtilDateRange* _tmp0_;
#line 28 "../src/Widgets/calendar/Grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = self->priv->_grid_range;
#line 28 "../src/Widgets/calendar/Grid.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/calendar/Grid.vala"
	return result;
#line 1708 "Grid.c"
}

static void
date_time_widgets_grid_set_grid_range (DateTimeWidgetsGrid* self,
                                       UtilDateRange* value)
{
	UtilDateRange* old_value;
#line 28 "../src/Widgets/calendar/Grid.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/calendar/Grid.vala"
	old_value = date_time_widgets_grid_get_grid_range (self);
#line 28 "../src/Widgets/calendar/Grid.vala"
	if (old_value != value) {
#line 1722 "Grid.c"
		UtilDateRange* _tmp0_;
#line 28 "../src/Widgets/calendar/Grid.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Widgets/calendar/Grid.vala"
		_g_object_unref0 (self->priv->_grid_range);
#line 28 "../src/Widgets/calendar/Grid.vala"
		self->priv->_grid_range = _tmp0_;
#line 28 "../src/Widgets/calendar/Grid.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_widgets_grid_properties[DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY]);
#line 1732 "Grid.c"
	}
}

static void
_date_time_widgets_grid_add_component_dots_date_time_widgets_calendar_model_components_added (DateTimeWidgetsCalendarModel* _sender,
                                                                                              ESource* source,
                                                                                              GeeCollection* components,
                                                                                              gpointer self)
{
#line 76 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_add_component_dots ((DateTimeWidgetsGrid*) self, source, components);
#line 1744 "Grid.c"
}

static void
_date_time_widgets_grid_remove_component_dots_date_time_widgets_calendar_model_components_removed (DateTimeWidgetsCalendarModel* _sender,
                                                                                                   ESource* source,
                                                                                                   GeeCollection* components,
                                                                                                   gpointer self)
{
#line 79 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_remove_component_dots ((DateTimeWidgetsGrid*) self, source, components);
#line 1755 "Grid.c"
}

static GObject *
date_time_widgets_grid_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DateTimeWidgetsGrid * self;
	GtkLabel** _tmp0_;
	GtkSeparator* week_sep = NULL;
	GtkSeparator* _tmp10_ = NULL;
	GtkRevealer* week_sep_revealer = NULL;
	GtkRevealer* _tmp11_ = NULL;
	GtkRevealer* _tmp12_;
	GtkSeparator* _tmp13_;
	GtkRevealer* _tmp14_;
	GSettings* _tmp15_;
	GtkRevealer* _tmp16_;
	GeeHashMap* _tmp17_;
	DateTimeWidgetsCalendarModel* _tmp18_;
	DateTimeWidgetsCalendarModel* _tmp19_;
	DateTimeWidgetsCalendarModel* _tmp20_;
	DateTimeWidgetsCalendarModel* _tmp21_;
#line 50 "../src/Widgets/calendar/Grid.vala"
	parent_class = G_OBJECT_CLASS (date_time_widgets_grid_parent_class);
#line 50 "../src/Widgets/calendar/Grid.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/Widgets/calendar/Grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_WIDGETS_TYPE_GRID, DateTimeWidgetsGrid);
#line 51 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = g_new0 (GtkLabel*, 7 + 1);
#line 51 "../src/Widgets/calendar/Grid.vala"
	self->priv->header_labels = (_vala_array_free (self->priv->header_labels, self->priv->header_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 51 "../src/Widgets/calendar/Grid.vala"
	self->priv->header_labels = _tmp0_;
#line 51 "../src/Widgets/calendar/Grid.vala"
	self->priv->header_labels_length1 = 7;
#line 51 "../src/Widgets/calendar/Grid.vala"
	self->priv->_header_labels_size_ = self->priv->header_labels_length1;
#line 1797 "Grid.c"
	{
		gint c = 0;
#line 52 "../src/Widgets/calendar/Grid.vala"
		c = 0;
#line 1802 "Grid.c"
		{
			gboolean _tmp1_ = FALSE;
#line 52 "../src/Widgets/calendar/Grid.vala"
			_tmp1_ = TRUE;
#line 52 "../src/Widgets/calendar/Grid.vala"
			while (TRUE) {
#line 1809 "Grid.c"
				GtkLabel** _tmp3_;
				gint _tmp3__length1;
				GtkLabel* _tmp4_;
				GtkLabel** _tmp5_;
				gint _tmp5__length1;
				GtkLabel* _tmp6_;
				GtkStyleContext* _tmp7_;
				GtkLabel** _tmp8_;
				gint _tmp8__length1;
				GtkLabel* _tmp9_;
#line 52 "../src/Widgets/calendar/Grid.vala"
				if (!_tmp1_) {
#line 1822 "Grid.c"
					gint _tmp2_;
#line 52 "../src/Widgets/calendar/Grid.vala"
					_tmp2_ = c;
#line 52 "../src/Widgets/calendar/Grid.vala"
					c = _tmp2_ + 1;
#line 1828 "Grid.c"
				}
#line 52 "../src/Widgets/calendar/Grid.vala"
				_tmp1_ = FALSE;
#line 52 "../src/Widgets/calendar/Grid.vala"
				if (!(c < 7)) {
#line 52 "../src/Widgets/calendar/Grid.vala"
					break;
#line 1836 "Grid.c"
				}
#line 53 "../src/Widgets/calendar/Grid.vala"
				_tmp3_ = self->priv->header_labels;
#line 53 "../src/Widgets/calendar/Grid.vala"
				_tmp3__length1 = self->priv->header_labels_length1;
#line 53 "../src/Widgets/calendar/Grid.vala"
				_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 53 "../src/Widgets/calendar/Grid.vala"
				g_object_ref_sink (_tmp4_);
#line 53 "../src/Widgets/calendar/Grid.vala"
				_g_object_unref0 (_tmp3_[c]);
#line 53 "../src/Widgets/calendar/Grid.vala"
				_tmp3_[c] = _tmp4_;
#line 54 "../src/Widgets/calendar/Grid.vala"
				_tmp5_ = self->priv->header_labels;
#line 54 "../src/Widgets/calendar/Grid.vala"
				_tmp5__length1 = self->priv->header_labels_length1;
#line 54 "../src/Widgets/calendar/Grid.vala"
				_tmp6_ = _tmp5_[c];
#line 54 "../src/Widgets/calendar/Grid.vala"
				_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 54 "../src/Widgets/calendar/Grid.vala"
				gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 56 "../src/Widgets/calendar/Grid.vala"
				_tmp8_ = self->priv->header_labels;
#line 56 "../src/Widgets/calendar/Grid.vala"
				_tmp8__length1 = self->priv->header_labels_length1;
#line 56 "../src/Widgets/calendar/Grid.vala"
				_tmp9_ = _tmp8_[c];
#line 56 "../src/Widgets/calendar/Grid.vala"
				gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp9_, c + 2, 0, 1, 1);
#line 1868 "Grid.c"
			}
		}
	}
#line 59 "../src/Widgets/calendar/Grid.vala"
	_tmp10_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 59 "../src/Widgets/calendar/Grid.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp10_, 9);
#line 59 "../src/Widgets/calendar/Grid.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp10_, 3);
#line 59 "../src/Widgets/calendar/Grid.vala"
	g_object_ref_sink (_tmp10_);
#line 59 "../src/Widgets/calendar/Grid.vala"
	week_sep = _tmp10_;
#line 64 "../src/Widgets/calendar/Grid.vala"
	_tmp11_ = (GtkRevealer*) gtk_revealer_new ();
#line 64 "../src/Widgets/calendar/Grid.vala"
	gtk_revealer_set_transition_type (_tmp11_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 64 "../src/Widgets/calendar/Grid.vala"
	g_object_ref_sink (_tmp11_);
#line 64 "../src/Widgets/calendar/Grid.vala"
	week_sep_revealer = _tmp11_;
#line 67 "../src/Widgets/calendar/Grid.vala"
	_tmp12_ = week_sep_revealer;
#line 67 "../src/Widgets/calendar/Grid.vala"
	_tmp13_ = week_sep;
#line 67 "../src/Widgets/calendar/Grid.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 69 "../src/Widgets/calendar/Grid.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 70 "../src/Widgets/calendar/Grid.vala"
	_tmp14_ = week_sep_revealer;
#line 70 "../src/Widgets/calendar/Grid.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, 1, 1, 1, 6);
#line 72 "../src/Widgets/calendar/Grid.vala"
	_tmp15_ = date_time_indicator_settings;
#line 72 "../src/Widgets/calendar/Grid.vala"
	_tmp16_ = week_sep_revealer;
#line 72 "../src/Widgets/calendar/Grid.vala"
	g_settings_bind (_tmp15_, "show-weeks", (GObject*) _tmp16_, "reveal-child", G_SETTINGS_BIND_DEFAULT);
#line 74 "../src/Widgets/calendar/Grid.vala"
	_tmp17_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, DATE_TIME_WIDGETS_TYPE_GRID_DAY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 74 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (self->priv->data);
#line 74 "../src/Widgets/calendar/Grid.vala"
	self->priv->data = _tmp17_;
#line 76 "../src/Widgets/calendar/Grid.vala"
	_tmp18_ = date_time_widgets_grid_events_model;
#line 76 "../src/Widgets/calendar/Grid.vala"
	g_signal_connect_object (_tmp18_, "components-added", (GCallback) _date_time_widgets_grid_add_component_dots_date_time_widgets_calendar_model_components_added, self, 0);
#line 77 "../src/Widgets/calendar/Grid.vala"
	_tmp19_ = date_time_widgets_grid_tasks_model;
#line 77 "../src/Widgets/calendar/Grid.vala"
	g_signal_connect_object (_tmp19_, "components-added", (GCallback) _date_time_widgets_grid_add_component_dots_date_time_widgets_calendar_model_components_added, self, 0);
#line 79 "../src/Widgets/calendar/Grid.vala"
	_tmp20_ = date_time_widgets_grid_events_model;
#line 79 "../src/Widgets/calendar/Grid.vala"
	g_signal_connect_object (_tmp20_, "components-removed", (GCallback) _date_time_widgets_grid_remove_component_dots_date_time_widgets_calendar_model_components_removed, self, 0);
#line 80 "../src/Widgets/calendar/Grid.vala"
	_tmp21_ = date_time_widgets_grid_tasks_model;
#line 80 "../src/Widgets/calendar/Grid.vala"
	g_signal_connect_object (_tmp21_, "components-removed", (GCallback) _date_time_widgets_grid_remove_component_dots_date_time_widgets_calendar_model_components_removed, self, 0);
#line 50 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (week_sep_revealer);
#line 50 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (week_sep);
#line 50 "../src/Widgets/calendar/Grid.vala"
	return obj;
#line 1936 "Grid.c"
}

static void
date_time_widgets_grid_class_init (DateTimeWidgetsGridClass * klass,
                                   gpointer klass_data)
{
	DateTimeWidgetsCalendarModel* _tmp0_;
	DateTimeWidgetsCalendarModel* _tmp1_;
#line 27 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Widgets/calendar/Grid.vala"
	g_type_class_adjust_private_offset (klass, &DateTimeWidgetsGrid_private_offset);
#line 27 "../src/Widgets/calendar/Grid.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_widgets_grid_get_property;
#line 27 "../src/Widgets/calendar/Grid.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_widgets_grid_set_property;
#line 27 "../src/Widgets/calendar/Grid.vala"
	G_OBJECT_CLASS (klass)->constructor = date_time_widgets_grid_constructor;
#line 27 "../src/Widgets/calendar/Grid.vala"
	G_OBJECT_CLASS (klass)->finalize = date_time_widgets_grid_finalize;
#line 27 "../src/Widgets/calendar/Grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY, date_time_widgets_grid_properties[DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY] = g_param_spec_object ("grid-range", "grid-range", "grid-range", UTIL_TYPE_DATE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_signals[DATE_TIME_WIDGETS_GRID_ON_EVENT_ADD_SIGNAL] = g_signal_new ("on-event-add", DATE_TIME_WIDGETS_TYPE_GRID, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_DATE_TIME);
#line 27 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_signals[DATE_TIME_WIDGETS_GRID_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", DATE_TIME_WIDGETS_TYPE_GRID, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_DATE_TIME);
#line 46 "../src/Widgets/calendar/Grid.vala"
	_tmp0_ = date_time_widgets_calendar_model_get_default (E_CAL_CLIENT_SOURCE_TYPE_EVENTS);
#line 46 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (date_time_widgets_grid_events_model);
#line 46 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_events_model = _tmp0_;
#line 47 "../src/Widgets/calendar/Grid.vala"
	_tmp1_ = date_time_widgets_calendar_model_get_default (E_CAL_CLIENT_SOURCE_TYPE_TASKS);
#line 47 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (date_time_widgets_grid_tasks_model);
#line 47 "../src/Widgets/calendar/Grid.vala"
	date_time_widgets_grid_tasks_model = _tmp1_;
#line 1975 "Grid.c"
}

static void
date_time_widgets_grid_instance_init (DateTimeWidgetsGrid * self,
                                      gpointer klass)
{
#line 27 "../src/Widgets/calendar/Grid.vala"
	self->priv = date_time_widgets_grid_get_instance_private (self);
#line 1984 "Grid.c"
}

static void
date_time_widgets_grid_finalize (GObject * obj)
{
	DateTimeWidgetsGrid * self;
#line 27 "../src/Widgets/calendar/Grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_WIDGETS_TYPE_GRID, DateTimeWidgetsGrid);
#line 28 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (self->priv->_grid_range);
#line 37 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (self->priv->data);
#line 38 "../src/Widgets/calendar/Grid.vala"
	_g_object_unref0 (self->priv->selected_gridday);
#line 39 "../src/Widgets/calendar/Grid.vala"
	self->priv->header_labels = (_vala_array_free (self->priv->header_labels, self->priv->header_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 40 "../src/Widgets/calendar/Grid.vala"
	self->priv->week_labels = (_vala_array_free (self->priv->week_labels, self->priv->week_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 27 "../src/Widgets/calendar/Grid.vala"
	G_OBJECT_CLASS (date_time_widgets_grid_parent_class)->finalize (obj);
#line 2005 "Grid.c"
}

/**
 * Represents the entire date grid as a table.
 */
static GType
date_time_widgets_grid_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeWidgetsGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_widgets_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeWidgetsGrid), 0, (GInstanceInitFunc) date_time_widgets_grid_instance_init, NULL };
	GType date_time_widgets_grid_type_id;
	date_time_widgets_grid_type_id = g_type_register_static (gtk_grid_get_type (), "DateTimeWidgetsGrid", &g_define_type_info, 0);
	DateTimeWidgetsGrid_private_offset = g_type_add_instance_private (date_time_widgets_grid_type_id, sizeof (DateTimeWidgetsGridPrivate));
	return date_time_widgets_grid_type_id;
}

GType
date_time_widgets_grid_get_type (void)
{
	static volatile gsize date_time_widgets_grid_type_id__once = 0;
	if (g_once_init_enter (&date_time_widgets_grid_type_id__once)) {
		GType date_time_widgets_grid_type_id;
		date_time_widgets_grid_type_id = date_time_widgets_grid_get_type_once ();
		g_once_init_leave (&date_time_widgets_grid_type_id__once, date_time_widgets_grid_type_id);
	}
	return date_time_widgets_grid_type_id__once;
}

static void
_vala_date_time_widgets_grid_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DateTimeWidgetsGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_WIDGETS_TYPE_GRID, DateTimeWidgetsGrid);
#line 27 "../src/Widgets/calendar/Grid.vala"
	switch (property_id) {
#line 27 "../src/Widgets/calendar/Grid.vala"
		case DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY:
#line 27 "../src/Widgets/calendar/Grid.vala"
		g_value_set_object (value, date_time_widgets_grid_get_grid_range (self));
#line 27 "../src/Widgets/calendar/Grid.vala"
		break;
#line 2049 "Grid.c"
		default:
#line 27 "../src/Widgets/calendar/Grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/calendar/Grid.vala"
		break;
#line 2055 "Grid.c"
	}
}

static void
_vala_date_time_widgets_grid_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DateTimeWidgetsGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_WIDGETS_TYPE_GRID, DateTimeWidgetsGrid);
#line 27 "../src/Widgets/calendar/Grid.vala"
	switch (property_id) {
#line 27 "../src/Widgets/calendar/Grid.vala"
		case DATE_TIME_WIDGETS_GRID_GRID_RANGE_PROPERTY:
#line 27 "../src/Widgets/calendar/Grid.vala"
		date_time_widgets_grid_set_grid_range (self, g_value_get_object (value));
#line 27 "../src/Widgets/calendar/Grid.vala"
		break;
#line 2075 "Grid.c"
		default:
#line 27 "../src/Widgets/calendar/Grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/calendar/Grid.vala"
		break;
#line 2081 "Grid.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

